require "util"
require "defines"
glob.specieOfTreeTable={"yellow","white"}
glob.randomResources={"coal", "coal", "coal",
					"iron-ore","iron-ore",
					"copper-ore","copper-ore",
					"stone","stone","stone",
					"gold-ore",
					"silver-ore",
					"bauxite-ore","bauxite-ore",
					"cassiterite","cassiterite"} 
glob.allowedremotecontrolledrobot={guns={},tools={"mining-drill"}}
if glob.boilernames==nil then
	glob.boilernames={"boiler"}
end

local loaded

game.onload(function()
	if not loaded then
		loaded = true
		local holes
		local hadHoles = false
		
		if glob.undergroundores ~= nil then
			for x,xd in pairs(glob.undergroundores) do
				for y, yd in pairs (xd) do
					local holes = game.findentitiesfiltered({area = {{x*32, y*32},{(x*32) + 32, (y*32) + 32}}, name = "holes"})
					if #holes == 0 then
						for k,v in pairs(yd.richness) do
							hadHoles = true
							break
						end
						
						if hadHoles then
							game.player.print("Resetting richness for chunk with no holes: " .. x .. ", " .. y)
							yd.richness = {}
							hadHoles = false
						end
						
						if glob.resetOres == nil then
							glob.undergroundores[x][y] = nil
						end
					end
				end
			end
		end
		
		if glob.resetOres == nil then
			glob.resetOres = true
		end
	end
end)

remote.addinterface("F-mod", {
	addboiler=function(boilername)
		table.insert(glob.boilernames, boilername)
	end,

	
	addumdresource=function(resource, freq)
	
		if type(resource)=="string" then
			if freq==nil then
				table.insert(glob.randomResources, resource)
			else
				for i=1, freq do
					table.insert(glob.randomResources, resource)
				end
			end
			
		elseif type(resource)=="table" then
			for i,d in pairs(resource) do
				if freq==nil then
					table.insert(glob.randomResources, d)
				else
					for ii=1, freq[i] do
						table.insert(glob.randomResources, d)
					end
				end
			end
		end
	end,
	
	addtree=function(tree)
		table.insert(glob.specieOfTreeTable, tree)
	end,
	resetrichness=function()
		for x,xd in pairs(glob.undergroundores) do
			for y, yd in pairs (xd) do
				yd.richness={}
			end
		end
	end,
	getredsatisfaction=function()
		return glob.planettrades.redsatisfaction;
	end,
	addtrade=function(trade)
		table.insert(glob.planettrades.trades,trade)
	end,
	resetores=function()
		glob.resetOres = nil
	end,
	fix=function()
		glob.planettrades.trades={}
		glob.planettrades.unlocked.oilred=nil
		glob.planettrades.unlocked.allplatesred=nil
		
	end
})
	


game.onevent(defines.events.ontick, function(event)
	if init==nil then
		init=true
		game.player.force.resetrecipes()
		game.player.force.resettechnologies()
		if glob.wireless==nil then
			glob.wireless={}
			glob.wireless.receivers={}
			glob.wireless.frequencies={}
		end
		if game.player.force.technologies["advanced-alien-drilling"].researched and game.player.force.recipes.umd.enabled==false then
			game.player.force.recipes.umd.enabled=true
		end
		if game.player.force.technologies.rocketry.researched and game.player.force.recipes["rocket-1"].enabled==false then
			game.player.force.recipes["rocket-1"].enabled=true
		end
	end
	if glob.prospectingcooldown~=nil and glob.prospectingcooldown~=0 then
		glob.prospectingcooldown=glob.prospectingcooldown-1
	end
	if glob.planettrades==nil then
		glob.planettrades={}
		glob.planettrades.redsatisfaction=0
		glob.planettrades.trades={}
	end
	if glob.planettrades.unlocked==nil then
		glob.planettrades.unlocked={}
	end
	if glob.planettrades.unlocked.oilred==nil and glob.planettrades.redsatisfaction>100 then
		
		glob.planettrades.unlocked.oilred=true
		game.player.print("You can now buy oil from the red planet! ")
		table.insert(glob.planettrades.trades,{name="Oil", description="1 crude oil barrel for 50 coins and 1 empty barrel", item={ {name="crude-oil-barrel",count=1} }, price={ {name="coin", count=50},{name="empty-barrel", count=1} }, planet="red"})
	end
	if glob.planettrades.unlocked.allplatesred==nil and glob.planettrades.redsatisfaction>25 then
		glob.planettrades.unlocked.allplatesred=true
		game.player.force.recipes["landing-platform"].enabled=true
		game.player.print("You can now sell copper, iron, aluminium, gold, silver and tin plates to the red planet! (You can also now create landing platforms)")
		table.insert(glob.planettrades.trades,{name="Iron plate", description="1 iron plate for 1 coin",item={ {name="coin",count=1} }, price={ {name="iron-plate", count=1} },planet="red"})
		table.insert(glob.planettrades.trades,{name="Copper plate", description="1 copper plate for 1 coin",item={ {name="coin",count=1} }, price={ {name="copper-plate", count=1} },planet="red"})
		table.insert(glob.planettrades.trades,{name="Aluminium plate", description="1 aluminium plate for 3 coin",item={ {name="coin",count=3} }, price={ {name="aluminium-plate", count=1} },planet="red"})
		table.insert(glob.planettrades.trades,{name="Gold plate", description="1 gold plate for 2 coin",item={ {name="coin",count=2} }, price={ {name="gold-plate", count=1} },planet="red"})
		table.insert(glob.planettrades.trades,{name="Silver plate", description="1 silver plate for 2 coin",item={ {name="coin",count=2} }, price={ {name="silver-plate", count=1} },planet="red"})
		table.insert(glob.planettrades.trades,{name="Tin plate", description="1 tin plate for 5 coin",item={ {name="coin",count=5} }, price={ {name="tin-plate", count=1} },planet="red"})
	end
	if glob.planettrades.unlocked.weaponsred1==nil and glob.planettrades.redsatisfaction>500 then
		glob.planettrades.unlocked.weaponsred1=true
		game.player.print("You can now sell basic weapons to the red planet! They really trust you, or they wouldn't buy something easily sabotageable.")
		table.insert(glob.planettrades.trades,{name="Pistol", description="1 pistol for 15 coins",item={ {name="coin",count=15} }, price={ {name="pistol", count=1} },planet="red"})
		table.insert(glob.planettrades.trades,{name="Sub machine gun", description="1 sub machine gun for 50 coins",item={ {name="coin",count=50} }, price={ {name="submachine-gun", count=1} },planet="red"})
		table.insert(glob.planettrades.trades,{name="Regular magazine", description="1 regular magazine for 3 coins",item={ {name="coin",count=3} }, price={ {name="basic-bullet-magazine", count=1} },planet="red"})
		table.insert(glob.planettrades.trades,{name="Piercing rounds magazine", description="1 piercing rounds magazine for 12 coins",item={ {name="coin",count=12} }, price={ {name="piercing-bullet-magazine", count=1} },planet="red"})
	end
	if glob.planettrades.unlocked.dynamite==nil and glob.planettrades.redsatisfaction>750 then
		glob.planettrades.unlocked.dynamite=true
		--glob.red_planet.valuables_market.addmarketitem{price={{"coin",100}}, offer={type="give-item", item="dynamite"}}
		game.player.print("You can now buy dynamite to the red planet!")
	end
	if glob.planettrades.unlocked.bigsubstation==nil and glob.planettrades.redsatisfaction>1000 then
		glob.planettrades.unlocked.bigsubstation=true
		glob.red_planet.valuables_market.addmarketitem{price={{"coin",2500}}, offer={type="give-item", item="big-substation"}}
		game.player.print("You can now buy big substations to the red planet!They are starting to share their tech!")
	end
	if glob.planettrades.unlocked.redtime1==nil and glob.planettrades.redsatisfaction>250 then
		glob.planettrades.unlocked.redtime1=true
		glob.redshiptime=18000
		game.player.print("The red ship will now visit the planet twice as much.")
	end
	if glob.planettrades.unlocked.redtime2==nil and glob.planettrades.redsatisfaction>1000 then
		glob.planettrades.unlocked.redtime2=true
		glob.redshiptime=9000
		game.player.print("The red ship will now visit the planet twice as much.")
	end
	if game.player.getitemcount("red-planet-point")>0 then
		for i=1,6 do
			if game.player.getinventory(i).getitemcount("red-planet-point")>0 then
				glob.planettrades.redsatisfaction=glob.planettrades.redsatisfaction+game.player.getinventory(i).getitemcount("red-planet-point")
				game.player.getinventory(i).remove{name="red-planet-point", count=game.player.getinventory(i).getitemcount("red-planet-point")}
			end
		end
	end

	if glob.allowedremotecontrolledrobot==nil then
		glob.allowedremotecontrolledrobot={guns={},tools={"mining-drill"}}
	end
	if glob.landingplatforms~=nil then
		for i,d in pairs(glob.landingplatforms) do
			
			if d.entity.valid and d~=nil and d.name~=nil and d.trade~=nil then
				if glob.redshiptime==nil then
					glob.redshiptime=36000
				end
				if event.tick%glob.redshiptime==0 then
					local trade=true
					for ii,dd in pairs(glob.planettrades.trades[d.trade].price) do
						if d.tradeamount~=nil then
							if d.entity.getinventory(1).getitemcount(dd.name)<(dd.count*d.tradeamount) then
								trade=false
								break
							end
						else
							trade=false
							break
						end
					end
					if trade==true then
						local inve=d.entity.getinventory(1)
						for ii,dd in pairs(glob.planettrades.trades[d.trade].price) do
							inve.remove{name=dd.name,count=(dd.count*d.tradeamount)}
						end
						for ii,dd in pairs(glob.planettrades.trades[d.trade].item) do
							inve.insert{name=dd.name,count=(dd.count*d.tradeamount)}
						end
					end
					
				end
			elseif d.entity.valid==false then
				table.remove(glob.landingplatforms,i)
			end
			
		end
	end
	if game.player.character~=nil and game.player.character.name=="remote-controlled-robot" then
		local guns=game.player.character.getinventory(3)
		for i,d in pairs(guns.getcontents()) do
			local allowed=false
			for ii,dd in pairs(glob.allowedremotecontrolledrobot.guns) do
				if dd==i then
					allowed=true
					break
				end
			end
			if allowed==false then
				guns.remove{name=i,count=d}
				game.player.character.getinventory(2).insert{name=i,count=d}
				game.player.print("A robot cant use this kind of thing!")
			end
		end
		local tools=game.player.character.getinventory(6)
		for i,d in pairs(tools.getcontents()) do
			local allowed=false
			for ii,dd in pairs(glob.allowedremotecontrolledrobot.tools) do
				if dd==i then
					allowed=true
					break
				end
			end
			if allowed==false then
				tools.remove{name=i,count=d}
				game.player.character.getinventory(2).insert{name=i,count=d}
				game.player.print("A robot cant use this kind of thing!")
			end
		end
	end
	if glob.burnerinserters~=nil then
		for i,d in pairs(glob.burnerinserters) do
			if d.valid then
				if d.getinventory(1).getitemcount("coal")<3 then
					if d.heldstack~=nil and d.heldstack.name=="coal" then
						d.getinventory(1).insert{name="coal", count=d.heldstack.count}
						d.heldstack=nil
					end
				end
			else
				table.remove(glob.burnerinserters,i)
			end
		end
	end
	if glob.rockets~=nil and event.tick%30==25 then
		for i,d in pairs(glob.rockets) do
			if d.entity.valid then
				inv=d.entity.getinventory(1)
				if d.entity.name=="rocket-1" then
					if inv.getitemcount("steel-plate")==100 and inv.getitemcount("engine-unit")==50 and
					inv.getitemcount("pipe")==50 and inv.getitemcount("advanced-circuit")==200 and
					inv.getitemcount("empty-barrel")==50 and inv.getitemcount("plastic-bar")==100 then
						
						local rocket=game.createentity{name="rocket-2", position=d.entity.position}
						d.entity.destroy()
						d.entity=rocket
						
					end
				elseif d.entity.name=="rocket-2" then 
					if inv.getitemcount("steel-plate")==100 and inv.getitemcount("iron-gear-wheel")==100 and
					inv.getitemcount("iron-plate")==100 and inv.getitemcount("plastic-bar")==100 and
					inv.getitemcount("electric-engine-unit")==50 and inv.getitemcount("advanced-circuit")==200 and
					inv.getitemcount("electronic-circuit")==200 and inv.getitemcount("copper-cable")==200 and
					inv.getitemcount("red-wire")==200 and inv.getitemcount("green-wire")==200 then
						
						local rocket=game.createentity{name="rocket-3",position=d.entity.position}
						d.entity.destroy()
						d.entity=rocket
						
					end
				elseif d.entity.name=="rocket-3" then
					if inv.getitemcount("steel-plate")==100 and inv.getitemcount("copper-cable")==400 and
					inv.getitemcount("iron-gear-wheel")==100 and inv.getitemcount("electronic-circuit")==200 and
					inv.getitemcount("advanced-circuit")==200 and inv.getitemcount("pipe")==50 and
					inv.getitemcount("iron-plate")==100 and inv.getitemcount("iron-stick")==100 and
					inv.getitemcount("plastic-bar")==100 then
					
						local rocket=game.createentity{name="rocket-4",position=d.entity.position}
						d.entity.destroy()
						d.entity=rocket
						
					end
				elseif d.entity.name=="rocket-4" then
					if inv.getitemcount("anten")==10 and inv.getitemcount("processing-unit")==100 and
					inv.getitemcount("electronic-circuit")==200 and inv.getitemcount("advanced-circuit")==200 and
					inv.getitemcount("steel-plate")==200 and inv.getitemcount("iron-plate")==100 and 
					inv.getitemcount("plastic-bar")==100 and inv.getitemcount("iron-stick")==100 and
					inv.getitemcount("soldering-tin")==100 then
					
						local rocket=game.createentity{name="rocket-5",position=d.entity.position}
						local landingp=game.createentity{name="landing-platform",position=d.entity.position} 
						landingp.operable=false 
						landingp.minable=false
						landingp.teleport{landingp.position.x-0.5,landingp.position.y} 
						if game.player.character.position.x>(d.entity.position.x-5) and game.player.character.position.x<(d.entity.position.x+5) and game.player.character.position.y>(d.entity.position.y-5) and game.player.character.position.y<(d.entity.position.y+5) then
							game.player.character.teleport{rocket.position.x,rocket.position.y+3}
						end
						d.entity.destroy()
						d.entity=rocket
						d.entity.destructible=false
						d.entity.minable=false
					end
				elseif d.entity.name=="rocket-5" then
					if game.player.opened~=nil and game.player.opened.position.x==d.entity.position.x and game.player.opened.position.y==d.entity.position.y and game.player.opened.name==d.entity.name then
						openedrocket=true
						glob.currentrocket=d
					elseif d.redrocket~=nil and game.player.opened~=nil and game.player.opened.position.x==d.redrocket.position.x and game.player.opened.position.y==d.redrocket.position.y and game.player.opened.name==d.redrocket.name then
						openedrocket=true
						glob.currentrocket=d
					elseif d.earthrocket~=nil and game.player.opened~=nil and game.player.opened.position.x==d.earthrocket.position.x and game.player.opened.position.y==d.earthrocket.position.y and game.player.opened.name==d.earthrocket.name then
						openedrocket=true
						glob.currentrocket=d
					else
						if openedrocket==true then
							openedrocket=false
							if glob.planet==nil then
								glob.planet="home"
							end
							if game.player.gui.center.planets==nil then
								game.player.gui.center.add{name="planets",type="frame",style="planets_background"} 
								game.player.gui.center.planets.add{name="vert",type="flow",direction="vertical"} 
								game.player.gui.center.planets.vert.add{name="hori1",type="flow",direction="horizontal"} 
								game.player.gui.center.planets.vert.add{name="hori2",type="flow",direction="horizontal"} 
								game.player.gui.center.planets.vert.add{name="hori3",type="flow",direction="horizontal"} 

								game.player.gui.center.planets.vert.hori1.add{name="spacing",type="button",style="inv",caption="    "} 

								game.player.gui.center.planets.vert.hori2.add{name="spacing1",type="button",style="inv", caption="    "} 
								game.player.gui.center.planets.vert.hori2.add{name="home",type="button",style="home_planet"} 
								game.player.gui.center.planets.vert.hori2.add{name="red",type="button",style="red_planet"} 
								game.player.gui.center.planets.vert.hori2.add{name="earth",type="button",style="earth"} 
								game.player.gui.center.planets.vert.hori2.add{name="spacing2",type="button",style="inv",caption="    "} 

								game.player.gui.center.planets.vert.hori3.add{name="exitplanets",type="button",style="planets_x"} 
								game.player.gui.center.planets.vert.hori3.add{name="spacing1",type="button",style="inv",caption="               "} 
								game.player.gui.center.planets.vert.hori3.add{name="fuel",type="progressbar",size=10,style="yellow_progressbar_style"} 
								if glob.currentrocket.fuel~=nil then
									game.player.gui.center.planets.vert.hori3.fuel.value=(glob.currentrocket.fuel/40)
								end
								game.player.gui.center.planets.vert.hori3.add{name="spacing2",type="button",style="inv",caption="               "} 
								game.player.gui.center.planets.vert.hori3.add{name="refuel",type="button",style="refuel"} 
								
								game.player.gui.center.planets.add{name="update",type="flow",direction="horizontal"} 
								game.player.gui.center.planets.update.destroy()
							end
						end
					end
				end
			end
		end
	end
	if glob.turretcars~=nil then
		for i,d in pairs(glob.turretcars) do
			if d.entity.valid and d.turret.valid then
				d.turret.teleport({d.entity.position.x,d.entity.position.y})
				d.turret.health=9999
			elseif d.turret.valid==false then
				d.turret=game.createentity{position={d.entity.position.x,d.entity.position.y},name="car-turret",force=game.player.character.force}
			else
				d.turret.destroy()
				table.remove(glob.turretcars,i)
			end
		end
	end
	--[[if glob.umd~=nil then
		for i,d in pairs(glob.umd) do
			if d.entity.valid and d.entity.energy>800 then
				d.entity.energy=d.entity.energy-800
			elseif d.entity.valid and d.entity.energy<800 then
				d.entity.energy=0
			end
		end 
	end]]
	if event.tick%60==8 and glob.umd~=nil then
		for i,d in pairs (glob.umd) do
			if d.entity.valid and d.entity.energy>800 then
				d.entity.energy=d.entity.energy-800
				local x=math.floor(d.entity.position.x / 32)
				local y=math.floor(d.entity.position.y / 32)
            
            local chest = nil
            if d.entity.direction==4 then
				drop_pos={d.entity.position.x+0.5 ,d.entity.position.y+2.3}
				chest = game.findentitiesfiltered{area={{d.entity.position.x+0.1 ,d.entity.position.y+2.1},{d.entity.position.x+1, d.entity.position.y+2.9}}, type="container"}
            elseif d.entity.direction==6 then
				drop_pos={d.entity.position.x-2.3 ,d.entity.position.y+0.5}
				chest = game.findentitiesfiltered{area={{d.entity.position.x-2.9, d.entity.position.y+0.1}, {d.entity.position.x-2.1 ,d.entity.position.y+0.9}}, type="container"}
            elseif d.entity.direction==0 then
				drop_pos={d.entity.position.x-0.5 ,d.entity.position.y-2.3}
				chest = game.findentitiesfiltered{area={{d.entity.position.x-0.9 ,d.entity.position.y-2.9},{d.entity.position.x-0.1, d.entity.position.y-2.1}}, type="container"}
            elseif d.entity.direction==2 then
				drop_pos={d.entity.position.x+2.3 ,d.entity.position.y-0.5}
				chest = game.findentitiesfiltered{area={{d.entity.position.x+2.1 ,d.entity.position.y-0.9},{d.entity.position.x+2.9, d.entity.position.y-0.1}}, type="container"}
            end
            if chest ~= nil and chest[1]~= nil and chest[1].name ~= "item-on-ground" then
				chest = chest[1]
            else
				chest = nil
            end
			if glob.undergroundores==nil then 
				glob.undergroundores={}
			end
			if glob.undergroundores[x]==nil then
				glob.undergroundores[x]={}
			end
			if glob.undergroundores[x][y]==nil then
				glob.undergroundores[x][y]={resource=glob.randomResources[math.random(1, #glob.randomResources)], richness={}}
			end
			if math.random(1,6)<d.rich then
				if chest ~=nil then
					chest.insert({name=glob.undergroundores[x][y].resource, count=1})
				elseif game.canplaceentity{name="item-on-ground" , stack={name=glob.undergroundores[x][y].resource}, position=drop_pos} then
					game.createentity{name="item-on-ground" , stack={name=glob.undergroundores[x][y].resource}, position=drop_pos}
				end
			else         
				if chest ~= nil then
					chest.insert({name="stone", count=1})
				  
				elseif game.canplaceentity{name="item-on-ground" , stack={name="stone"}, position=drop_pos} then
					game.createentity{name="item-on-ground" , stack={name="stone"}, position=drop_pos}
				end
			end
			elseif d.entity.valid==false then
				table.remove(glob.umd, i)
			end
		end
	end
	if turnonmissile==true then
		glob.missile=true
		turnonmissile=false
		glob.missilecount=0
		glob.character=game.player.character
		game.player.setcontroller{type=defines.controllers.ghost}
		game.player.teleport(glob.character.position)
		cap=tostring(math.ceil(game.player.position.x))..", "..tostring(math.ceil(game.player.position.y)).."     "..tostring(math.ceil(glob.character.position.x)).."±100, "..tostring(math.ceil(glob.character.position.y)).."±100"
		game.player.gui.center.add({type="frame", name="menus", caption=cap,direction="vertical",style="missile_menu"})
		game.player.gui.center.menus.add({type="button", name="missile", caption=" ",style="inv_button"})
	end
	if glob.onetime==nil then
		if game.player~=nil then
			game.player.insert{name="pda",count=2}
		end
		glob.onetime=true
	end
	if glob.firstTicks==nil then
		glob.firstTicks={count=0,status=true}
	end
	if glob.firstTicks.status==true then
		glob.firstTicks.count=glob.firstTicks.count+1
		if glob.firstTicks.count==4800 then
			glob.firstTicks.status=false
		end
	end
	if glob.artifacts~=nil and event.tick%60==0 then
		for i,_ in pairs(glob.artifacts) do
			local entities=game.findentities({{glob.artifacts[i].position.x-1,glob.artifacts[i].position.y-1},{glob.artifacts[i].position.x+1,glob.artifacts[i].position.y+1}})
			for x,_ in pairs(entities) do
				if entities[x].valid and entities[x].name=="artifact-collector" then
					local artifacts=game.findentities({{glob.artifacts[i].position.x-20,glob.artifacts[i].position.y-20},{glob.artifacts[i].position.x+20,glob.artifacts[i].position.y+20}})
					for z,_ in pairs(artifacts) do 
						if artifacts[z].name=="item-on-ground" and artifacts[z].stack.name=="small-alien-artifact" and entities[x].caninsert{name="small-alien-artifact",count=1} then
							entities[x].insert{name="small-alien-artifact",count=1}
							 game.createentity({name="alien-artifact-pickup",position={artifacts[z].position.x,artifacts[z].position.y+0.5}})
							artifacts[z].destroy()
							break
						end
					end
				end
			end
		end
	end
	if glob.drillingtowers~=nil and event.tick%60==22 then
		for i,d in pairs (glob.drillingtowers) do
			if d.entity.valid then
				if d.entity.recipe~=nil and d.entity.recipe.name=="find-ore" then
					if d.entity.getitemcount("find-ore")==1 then
						d.entity.active=false
						d.entity.getinventory(2).clear()
						local hole=game.createentity{name="holes", position={d.entity.position.x,d.entity.position.y}}
						if glob.undergroundores==nil then
							glob.undergroundores={}
						end
						if glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32]==nil then
							glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32]={}
						end
						if glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32][(d.entity.position.y-d.entity.position.y%32)/32]==nil then
							glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32][(d.entity.position.y-d.entity.position.y%32)/32]={}
							glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32][(d.entity.position.y-d.entity.position.y%32)/32].resource=glob.randomResources[math.random(1, #glob.randomResources)]
							glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32][(d.entity.position.y-d.entity.position.y%32)/32].richness={}
						end
						
						if glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32][(d.entity.position.y-d.entity.position.y%32)/32].richness[d.entity.position.x%32]==nil then
							glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32][(d.entity.position.y-d.entity.position.y%32)/32].richness[d.entity.position.x%32]={}
						end
						if glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32][(d.entity.position.y-d.entity.position.y%32)/32].richness[d.entity.position.x%32][(d.entity.position.y%32)]==nil then
							glob.undergroundores[(d.entity.position.x-d.entity.position.x%32)/32][(d.entity.position.y-d.entity.position.y%32)/32].richness[d.entity.position.x%32][(d.entity.position.y%32)]=math.random(5)
						end
						game.createentity({name = "item-on-ground", position = d.entity.position, stack = {name = "drilling-tower", count = 1}})
						d.entity.destroy()
					elseif d.entity.operable==true then
						d.entity.operable=false
					end
				end
			else
				table.remove(glob.drillingtowers, i)
			end
		end
	end
	if glob.destroyer~=nil and math.random(30)==1 then 					--[[Item destroyer]]--
		for i,d in pairs(glob.destroyer) do
			if d.entity.valid then
				d.entity.getinventory(defines.inventory.chest).clear()
			else
				table.remove(glob.destroyer,i)
			end
		end
	end
	if glob.stonepiles~=nil and event.tick%60==0 then 					--[[Stone pile tick]]--
		for i,d in pairs(glob.stonepiles) do
			if d.entity.valid then
				local stonecount=d.entity.getitemcount("stone")
				if stonecount>0 then
					d.entity.getinventory(1).remove{name="stone",count=stonecount}
				end
				if d.entity.getinventory(1).getitemcount("waste")~=0 then
					scrapcount=99-d.entity.getinventory(1).getitemcount("waste")
				else
					scrapcount=99
				end
				scrap=d.entity.getinventory(1).getitemcount("waste")
				if scrapcount>=1 then
					d.entity.insert({name="waste",count=scrapcount})
				end
				if d.entity.getinventory(1).caninsert({name="waste",count=1})==false then
					d.entity.getinventory(1).clear()
					if stonecount~=0 then
						d.entity.insert{name="stone",count=stonecount}
					end
					d.entity.insert({name="waste",count=5+scrap})
				else
					d.entity.getinventory(1).clear()
					if stonecount~=0 then
						d.entity.insert{name="stone",count=stonecount}
					end
					if scrap>=1 then
						d.entity.insert({name="waste",count=scrap})
					end
				end
					
			end
		end
	end
	if glob.saltpiles~=nil and event.tick%60==0 then 					--[[Salt pile tick]]--
		for i,d in pairs(glob.saltpiles) do
			if d.entity.valid then
				local saltcount=d.entity.getitemcount("salt")
				if saltcount>0 then
					d.entity.getinventory(1).remove{name="salt",count=saltcount}
				end
				if d.entity.getinventory(1).getitemcount("waste")~=0 then
					scrapcount=99-d.entity.getinventory(1).getitemcount("waste")
				else
					scrapcount=99
				end
				scrap=d.entity.getinventory(1).getitemcount("waste")
				if scrapcount>=1 then
					d.entity.insert({name="waste",count=scrapcount})
				end
				if d.entity.getinventory(1).caninsert({name="waste",count=1})==false then
					d.entity.getinventory(1).clear()
					if saltcount~=0 then
						d.entity.insert{name="salt",count=saltcount}
					end
					d.entity.insert({name="waste",count=5+scrap})
				else
					d.entity.getinventory(1).clear()
					if saltcount~=0 then
						d.entity.insert{name="salt",count=saltcount}
					end
					if scrap>=1 then
						d.entity.insert({name="waste",count=scrap})
					end
				end
					
			end
		end
	end
	if glob.saltextractors~=nil and event.tick%180==0 then				--[[Salt extractor]]--
		for i,_ in pairs(glob.saltextractors) do
			if glob.saltextractors[i].entity.valid then
				local pumps=game.findentities{{glob.saltextractors[i].entity.position.x-2,glob.saltextractors[i].entity.position.y-2,},{glob.saltextractors[i].entity.position.x+2,glob.saltextractors[i].entity.position.y+2}}
				pumpnear=false
				for y,_ in pairs(pumps) do
					if pumps[y].name=="pipe-to-ground" then
						liquid=pumps[y].fluidbox[1]
						if liquid ~= nil and liquid.amount~=0 then
							pumpnear=true
							break
						end
					end
				end
				if pumpnear==true then
					glob.saltextractors[i].entity.insert{name="salt",count=1}
				end
			else
				table.remove(glob.saltextractors,i)
			end
		end
	end
	if glob.water~=nil and event.tick%30==8 then						--[[Water collector]]--
		for i,d in pairs(glob.water) do
			foundwater=false
			if d.entity.valid then
				local pipes=game.findentitiesfiltered{area={{d.entity.position.x-2,d.entity.position.y-2,},{d.entity.position.x+2,d.entity.position.y+2}},name="pipe-to-ground"}
				for index,data in pairs(pipes) do
					if data.fluidbox[1].amount~=0 then
						foundwater=true
					end
				end
				if foundwater==true then
					d.entity.active=true
				else
					d.entity.active=false
				end
			else
				table.remove(glob.water,i)
			end
		end
	end
	if glob.dynamite~=nil then											--[[Dynamite]]--
		for i,_ in pairs(glob.dynamite) do
			glob.dynamite[i].timer=glob.dynamite[i].timer+1
			if glob.dynamite[i].entity.valid and glob.dynamite[i].timer==600  then
				game.createentity({name="huge-explosion",position=glob.dynamite[i].entity.position})
				posi=glob.dynamite[i].entity.position
				for pos=0,10,2.5 do
					local entities=game.findentities({{posi.x-pos,posi.y-pos},{posi.x+pos,posi.y+pos}})
					for i,_ in pairs(entities) do
						if entities[i].health~=nil then
							entities[i].damage(50,game.player.force)
						elseif entities[i].name=="iron-ore" or entities[i].name=="copper-ore" or entities[i].name=="coal" or entities[i].name=="stone" then
							entities[i].amount=entities[i].amount-1
							game.createentity{name="item-on-ground", position=entities[i].position, stack={name=entities[i].name}}
							if entities[i].amount<=0 then
								entities[i].destroy()
							end
						end
					end
				end
				glob.dynamite[i].entity.destroy()
				table.remove(glob.dynamite ,i) 
			elseif glob.dynamite[i].entity.valid==false then
				table.remove(glob.dynamite, i)
			elseif glob.dynamite[i].entity.valid and glob.dynamite[i].entity.health~=100000 and glob.dynamite[i].timer<570 then
				glob.dynamite[i].timer=570
				glob.dynamite[i].entity.health=100000
			end
		end
	end
	if glob.wireless.frequencies~=nil then								--[[Wireless tick]]--
		if glob.wireless.frequencies[event.tick%101]~=nil then
			for i,entity in pairs(glob.wireless.frequencies[event.tick%101]) do
				if type(entity)~="boolean" and entity.valid==false then
					table.remove(glob.wireless.frequencies[event.tick%101],i)
				elseif type(entity)~="boolean" then
					local entities=game.findentities({{entity.position.x-1,entity.position.y-1},{entity.position.x+1,entity.position.y+1}})
					for y,z in pairs(entities) do
						if z.name~="player" and z.force.name=="player" and z.name~="door-closed" and z.name~="door-opened" then
							z.active=glob.wireless.frequencies[event.tick%101].active
						elseif z.name=="door-closed" and glob.wireless.frequencies[event.tick%101].active then
							local ent=game.createentity({name="door-opened",position=z.position})
							ent.health=z.health
							z.destroy()
						elseif z.name=="door-opened" and glob.wireless.frequencies[event.tick%101].active==false then
							local ent=game.createentity({name="door-closed",position=z.position})
							ent.health=z.health
							z.destroy()
						end
					end
				end
			end
		end
	end

	if event.tick%3600==0 then											--[[Tree tick]]--
		for _,specie in pairs (glob.specieOfTreeTable) do
			if glob[specie.."trees"]~=nil then
				for i,d in pairs(glob[specie.."trees"]) do
					if d.entity.valid then
						if math.random(5)--[[==1]] and d.entity.name==specie.."-tree-1" or math.random(5)--[[==1]] and d.entity.name==specie.."-tree-2" or math.random(5)--[[==1]] and d.entity.name==specie.."-tree-3" then
							d.entity.insert({name=specie.."-berry",count=1})
						end
					else
						table.remove(glob[specie.."trees"],i)
					end
				end
			end
		end
	end
	if glob.missilecount~=nil and glob.missilecount~=0 then
		glob.missilecount=glob.missilecount+1
		if glob.missilecount==600 then
			game.player.gui.center.menus.destroy()
			game.player.setcontroller{type=defines.controller.character, character=glob.character}
			glob.missilecount=0
		end
	end
	if event.tick%108000==1 and glob.fishfarms~=nil then
		for i,d in pairs(glob.fishfarms) do
			if d.entity.valid then
				if d.entity.getitemcount("raw-fish")%2==0 then
					fishes=d.entity.getitemcount("raw-fish")/2
				else
					fishes=(d.entity.getitemcount("raw-fish")-1)/2
				end
				if fishes>=1 then
					d.entity.insert{name="raw-fish",count=fishes}
				end
			else
				table.remove(glob.fishfarms,i)
			end
		end
	end
	if event.tick%60==18 then
		for _,specie in pairs (glob.specieOfTreeTable) do
			if glob[specie.."trees"]~=nil then
				for i,d in pairs(glob[specie.."trees"]) do
					if d.time~=nil then
						d.time=d.time+1
						if d.time== 180 and d.entity.valid then
							if d.entity.name=="small-"..specie.."-tree-1" or d.entity.name== "small-"..specie.."-tree-2" or d.entity.name == "small-"..specie.."-tree-3" then
								local createdentity=game.createentity({name="medium-"..specie.."-tree-"..math.random(3), position=d.entity.position})
								d.entity.destroy()
								d.entity=createdentity
								d.time=0
							else
								local createdentity=game.createentity( {name=(specie.."-tree-"..math.random(3)), position=d.entity.position} )
								d.entity.destroy()
								d.entity=createdentity
								d.time=nil
							end
						elseif d.entity.valid==false then
							table.remove(glob[specie.."trees"],i)
						end
					end
				end
			end
		end
	end
end)
game.onevent(defines.events.onbuiltentity, function(event)
	if event.createdentity.name == "rocket-1" or event.createdentity.name == "rocket-2" or event.createdentity.name == "rocket-3" or event.createdentity.name == "rocket-4" or event.createdentity.name == "rocket-5" then
		if glob.rockets==nil then
			glob.rockets={}
		end
		table.insert(glob.rockets,{entity=event.createdentity})
		if event.createdentity.name == "rocket-1" then
			game.player.print("You need to put inside the rocket inventory the resources to build the second stage. To see what you need you need to click on the rocket with the PDA.")
		end
	end
	if event.createdentity.name == "remote-controlled-robot" then --[[Remote controlled build]]--
		event.createdentity.insert{name="pda",count="2"}
	end
	if event.createdentity.name == "turret-car" then --[[Turret car build]]--
		if glob.turretcars==nil then
			glob.turretcars={}
		end
		local turret=game.createentity{position={event.createdentity.position.x,event.createdentity.position.y},name="car-turret",force=game.player.character.force}
		table.insert(glob.turretcars,{entity=event.createdentity,turret=turret})
	end
	if event.createdentity.name == "burner-inserter" then --[[Burner inserter build]]--
		if glob.burnerinserters==nil then
			glob.burnerinserters={}
		end
		table.insert(glob.burnerinserters,event.createdentity)
	end
	if event.createdentity.name == "umd" then --[[UMD build]]--
		if glob.umd==nil then
			glob.umd={}
		end
		event.createdentity.active=false
		local rx1=(event.createdentity.position.x-(event.createdentity.position.x)%32)/32
		local ry1=(event.createdentity.position.y-(event.createdentity.position.y)%32)/32
		local rx2=event.createdentity.position.x%32
		local ry2=event.createdentity.position.y%32
		
		if glob.undergroundores==nil then
			glob.undergroundores={}
		end
		if glob.undergroundores[rx1]==nil then
			glob.undergroundores[rx1]={}
		end
		if glob.undergroundores[rx1]==nil then
			glob.undergroundores[rx1]={}
		end
		if glob.undergroundores[rx1][ry1]==nil then
			glob.undergroundores[rx1][ry1]={}
		end
		if glob.undergroundores[rx1][ry1].richness==nil then
			glob.undergroundores[rx1][ry1].richness={}
		end
		if glob.undergroundores[rx1][ry1].richness[rx2]==nil then
			glob.undergroundores[rx1][ry1].richness[rx2]={}
		end
		if glob.undergroundores[rx1][ry1].richness[rx2][ry2]==nil then
			glob.undergroundores[rx1][ry1].richness[rx2][ry2]=math.random(5)
		end
		local richness = glob.undergroundores[rx1][ry1].richness[rx2][ry2]
		table.insert(glob.umd, {entity=event.createdentity, rich=richness})

		if richness==1 then
			game.player.print("Found "..glob.undergroundores[rx1][ry1].resource.." with a awful richness")
		elseif richness==2 then
			game.player.print("Found "..glob.undergroundores[rx1][ry1].resource.." with a bad richness")
		elseif richness==3 then
			game.player.print("Found "..glob.undergroundores[rx1][ry1].resource.." with a medium richness")
		elseif richness==4 then
			game.player.print("Found "..glob.undergroundores[rx1][ry1].resource.." with a good richness")
		elseif richness==5 then
			game.player.print("Found "..glob.undergroundores[rx1][ry1].resource.." with a premium richness")
		end

	end
	if event.createdentity.name == "stone-pile" then						 --[[Stone pile build]]--
		if glob.stonepilescount==nil then
			glob.stonepiles={}
			glob.stonepilescount=0
		end
		glob.stonepilescount=glob.stonepilescount+1
		glob.stonepiles[glob.stonepilescount]={}
		glob.stonepiles[glob.stonepilescount].entity=event.createdentity
	end
	if event.createdentity.name == "salt-pile" then							 --[[Salt pile build]]--
		if glob.saltpilescount==nil then
			glob.saltpiles={}
			glob.saltpilescount=0
		end
		glob.saltpilescount=glob.saltpilescount+1
		glob.saltpiles[glob.saltpilescount]={}
		glob.saltpiles[glob.saltpilescount].entity=event.createdentity
	end
	if event.createdentity.name=="fish-farm" then
		if glob.fishfarms==nil then
			glob.fishfarms={}
		end
		table.insert(glob.fishfarms,{entity=event.createdentity})
	end
	if event.createdentity.name == "salt-extractor" then					--[[Salt extractor build]]--
		if glob.saltextractors==nil then
			glob.saltextractors={}
			glob.saltextractorscount=0
		end
		glob.saltextractorscount=glob.saltextractorscount+1
		glob.saltextractors[glob.saltextractorscount]={}
		glob.saltextractors[glob.saltextractorscount].entity=event.createdentity

	end
	
	if event.createdentity.name == "drilling-tower" then
		if glob.drillingtowers==nil then
			glob.drillingtowers={}
		end
		table.insert(glob.drillingtowers,{entity=event.createdentity})
	end
	
	for i,d in pairs(glob.boilernames) do
		if event.createdentity.name == d then							--[[Boiler build]]--
			if glob.boilers==nil then
				glob.boilers={}
				glob.boilerscount=0
			end
			glob.boilerscount=glob.boilerscount+1
			glob.boilers[glob.boilerscount]={}
			glob.boilers[glob.boilerscount].entity=event.createdentity
		end
	end

	if event.createdentity.name == "water-collector" then  					--[[Water collector build]]--
		if glob.water==nil then
			glob.water={}
		end
		table.insert(glob.water,{entity=event.createdentity})
	end
	if event.createdentity.name == "artifact-collector" then				--[[Artifact collector build]]--
		if glob.artifacts==nil then
			glob.artifacts={}
			glob.artifactscount=0
		end
		glob.artifactscount=glob.artifactscount+1
		glob.artifacts[glob.artifactscount]={}
		glob.artifacts[glob.artifactscount].position=event.createdentity.position
	end
	if event.createdentity.name == "item-destroyer" then				 	--[[Item destroyer build]]--
		if glob.destroyercount==nil then
			glob.destroyer={}
			glob.destroyercount=0
		end
		glob.destroyercount=glob.destroyercount+1
		glob.destroyer[glob.destroyercount]={}
		glob.destroyer[glob.destroyercount].entity=event.createdentity
		event.createdentity.operable=false
	end
	if event.createdentity.name=="dynamite" then							--[[Dynamite build]]--
		if glob.dynamite==nil then
			glob.dynamite={}
			glob.dynamitecount=0
		end
		glob.dynamite[glob.dynamitecount]={}
		glob.dynamite[glob.dynamitecount].entity=event.createdentity
		glob.dynamite[glob.dynamitecount].timer=0
		glob.dynamitecount=glob.dynamitecount+1		
		event.createdentity.operable=false
	end
	if event.createdentity.name == "pda" then								--[[PDA build]]--
		if game.player~=nil then
			game.player.insert{name="pda",count=1}
		end
		event.createdentity.destroy()
		if game.player.selected~=nil then
			if game.player.selected.name=="rocket-1" then
				game.player.print("You need 100 steel plates, 50 engine units, 50 pipes, 200 advanced circuits, 50 empty barrels, and 100 plastic bars to finish this stage.")
			elseif game.player.selected.name=="rocket-2" then
				game.player.print("You need 100 steel plates, 100 iron gear wheels, 100 iron plates, 100 plastic bars, 50 electric engine units, 200 advanced circuits, 200 electronic circuits, 200 copper cables, 200 red wires and 200 green wires to finish this stage.")
			elseif game.player.selected.name=="rocket-3" then
				game.player.print("You need 100 steel plates, 400 copper cables, 100 iron gear wheels, 200 advanced circuits, 200 electronic circuits, 50 pipes, 100 iron plates, 100 iron sticks and 100 plastic bars to finish this stage")
			elseif game.player.selected.name=="rocket-4" then
				game.player.print("You need 10 antens, 100 processing units, 200 electronic circuits, 200 advanced circuits, 200 steel plates, 100 iron plates, 100 plastic bars, 100 iron sticks, and 100 soldering tin.")
			end
		end
		if game.player.selected~=nil and game.player.selected.valid and game.player.selected.name=="wireless-base" then
			hasset=false
			if glob.wireless.frequencies~=nil then
				for i,d in pairs(glob.wireless.frequencies) do
					for index,data in pairs(d) do
						if type(data)~="boolean" and data.position.x==game.player.selected.position.x and data.position.y==game.player.selected.position.y then
							game.player.print("Frequency: "..i)
							hasset=true
							break
						end
					end
				end
			end
			if hasset==false then
				game.player.print("This wireless base havent got the frequency set")
			end
		else
			if game.player.gui.left.menu==nil then
				extend()
			end
		end
	elseif event.createdentity.name == "soldering-iron" then							--[[Soldering iron build]]--
		if event.createdentity.health>0 then
			game.player.insert{name="soldering-iron",count=1, health=(event.createdentity.health-1)/20}
			if game.player.gui.left.menu==nil then
				extendsoldering()
				event.createdentity.destroy()
			end
				
		else
			game.player.print("The soldering iron doesn't have enough battery")
			game.player.insert{name="soldering-iron",count=1, health=0}
			event.createdentity.destroy()
			
		end
	elseif string.find(event.createdentity.name,"-berry")~=nil then						--[[Berries build]]--
		specie = string.gsub(event.createdentity.name, '%-berry', '')
		if glob[specie.."trees"]==nil then
			glob[specie.."trees"]={}
		end
		table.insert(glob[specie.."trees"], {entity=game.createentity({name="small-"..specie.."-tree-"..math.random(3), position=event.createdentity.position}), time=0})
		event.createdentity.destroy()
	elseif event.createdentity.name == "flooring" then
		cantplace=nil
		for x=-1,1 do
			for y=-1,1 do
				if string.find(game.gettile(event.createdentity.position.x+x, event.createdentity.position.y+y).name, "water")~=nil then
					cantplace=true
					game.player.print("cant place")
					break
				end
			end
		end
		game.player.print(game.gettile(event.createdentity.position.x, event.createdentity.position.y).name)
		if cantplace==true or game.gettile(event.createdentity.position.x,event.createdentity.position.y).name=="floor" then
			game.player.character.insert{name="flooring",count=1}
		else
			game.settiles{{position={event.createdentity.position.x+1,event.createdentity.position.y},name="floor"}}
			game.settiles{{position={event.createdentity.position.x+1,event.createdentity.position.y+1},name="floor"}}
			game.settiles{{position={event.createdentity.position.x+1,event.createdentity.position.y-1},name="floor"}}
			game.settiles{{position={event.createdentity.position.x,event.createdentity.position.y+1},name="floor"}}
			game.settiles{{position={event.createdentity.position.x,event.createdentity.position.y},name="floor"}}
			game.settiles{{position={event.createdentity.position.x,event.createdentity.position.y-1},name="floor"}}
			game.settiles{{position={event.createdentity.position.x-1,event.createdentity.position.y},name="floor"}}
			game.settiles{{position={event.createdentity.position.x-1,event.createdentity.position.y+1},name="floor"}}
			game.settiles{{position={event.createdentity.position.x-1,event.createdentity.position.y-1},name="floor"}}
		end
		event.createdentity.destroy()
	elseif event.createdentity.name == "bridge" then  --[[Bridge build]]--
		game.settiles{{position=event.createdentity.position,name="bridge"}}
		event.createdentity.destroy()
	elseif event.createdentity.name == "prospecting-device" then --[[Prospecting device build]]--
		if glob.prospectingcooldown==nil or glob.prospectingcooldown==0 then
			glob.prospectingcooldown=60
			if event.createdentity.health>0 then
				if glob.undergroundores==nil then
					glob.undergroundores={}
				end
				if glob.undergroundores[(event.createdentity.position.x-event.createdentity.position.x%32)/32]==nil then
					glob.undergroundores[(event.createdentity.position.x-event.createdentity.position.x%32)/32]={}
				end
				if glob.undergroundores[(event.createdentity.position.x-event.createdentity.position.x%32)/32][(event.createdentity.position.y-event.createdentity.position.y%32)/32]==nil then
					glob.undergroundores[(event.createdentity.position.x-event.createdentity.position.x%32)/32][(event.createdentity.position.y-event.createdentity.position.y%32)/32]={}
					glob.undergroundores[(event.createdentity.position.x-event.createdentity.position.x%32)/32][(event.createdentity.position.y-event.createdentity.position.y%32)/32].resource=glob.randomResources[math.random(1, #glob.randomResources)]
					glob.undergroundores[(event.createdentity.position.x-event.createdentity.position.x%32)/32][(event.createdentity.position.y-event.createdentity.position.y%32)/32].richness={}
				end
				game.player.print("Found "..glob.undergroundores[(event.createdentity.position.x-event.createdentity.position.x%32)/32][(event.createdentity.position.y-event.createdentity.position.y%32)/32].resource..".")
				game.player.insert{name="prospecting-device",health=(event.createdentity.health-1)/10,count=1}
				event.createdentity.destroy()
			else
				game.player.print("The prospecting device doesnt have enough battery")
				game.player.insert{name="prospecting-device",health=(event.createdentity.health/150),count=1}
				event.createdentity.destroy()
			end
		else
			game.player.insert{name="prospecting-device",health=(event.createdentity.health/150),count=1}
			event.createdentity.destroy()
		end
	elseif event.createdentity.name == "landing-platform" then --[[Landing platform build]]--
		if glob.landingplatforms == nil then
			glob.landingplatforms={}
		end
		if game.player.gui.center.lpname==nil then
			table.insert(glob.landingplatforms,{entity=event.createdentity})
			game.player.gui.center.add{type="frame",name="lpname",caption="Landing platform name ("..#glob.landingplatforms..")"} 
			game.player.gui.center.lpname.add{type="textfield",name="lpnamebox"} 
			game.player.gui.center.lpname.add{type="button",name="donelp",caption="Done"} 
		else
			event.createdentity.destroy()
			game.player.character.insert{name="landing-platform",count=1}
		end
	end
end)

game.onevent(defines.events.onchunkgenerated, function(event)
	
	local x = event.area.lefttop.x/32
	local y = event.area.lefttop.y/32
	--[[
	if glob.undergroundores==nil then
		glob.undergroundores={}
	end
	if glob.undergroundores[x]==nil then
		glob.undergroundores[x]={}
	end
	glob.undergroundores[x][y]={resource=glob.randomResources[math.random(1, #glob.randomResources)], richness={}}
	]]
--	if y<200 and math.random(5)==1 then
--		local specieOfTree=glob.specieOfTreeTable[math.random(#glob.specieOfTreeTable)]
--		local treex = event.area.lefttop.x+math.random(32)
--		local treey = event.area.lefttop.y+math.random(32)
--		local typeoftree = math.random(3)
--		
--		if glob[specieOfTree.."trees"]==nil then
--			glob[specieOfTree.."trees"]={}
--		end
--		if game.canplaceentity{name=(specieOfTree.."-tree-"..typeoftree), position={treex,treey}} then
--			local createdentity=game.createentity{name=(specieOfTree.."-tree-"..typeoftree), position={treex,treey}, force=game.forces.neutral}
--			table.insert(glob[specieOfTree.."trees"], {entity=createdentity} )
--		end
--	end

	if y > 200 and y < 400 and x < 200 and x > -200 then
		local tiles={}
		local entities=game.findentities{{event.area.lefttop.x,event.area.lefttop.y},{event.area.lefttop.x+32,event.area.lefttop.y+32}}
		for i,d in pairs(entities) do
			if d.name~="player" and d.name~="planetmarket" and d.name~="house" and d.name~="red-stone-rock" and d.name~="rocket-5" then
				d.destroy()
			end
		end
		for xx=0,31 do
			for yy=0,31 do
				table.insert(tiles, {position={event.area.lefttop.x+xx,event.area.lefttop.y+yy},name="red-sand"})
			end
		end
		game.settiles(tiles)
		if y~=300 and x~=0 then
			amount=math.random(10)
			for i=1,amount do
				for i=1,10 do
					if game.canplaceentity{name="red-stone-rock", position={event.area.lefttop.x+math.random(32),event.area.lefttop.y+math.random(32)}} then
						game.createentity{name="red-stone-rock", position={event.area.lefttop.x+math.random(32),event.area.lefttop.y+math.random(32)}}
						break
					end
				end
			end
			amount=math.random(3)
			for i=1,amount do
				for i=1,10 do
					if game.canplaceentity{name="red-hole", position={event.area.lefttop.x+math.random(32),event.area.lefttop.y+math.random(32)}} then
						game.createentity{name="red-hole", position={event.area.lefttop.x+math.random(32),event.area.lefttop.y+math.random(32)}}
						break
					end
				end
			end
		end
	end
	if y==300 and x==0 then
		if glob.red_planet==nil then
			glob.red_planet={}
		end
		glob.red_planet.valuables_market=game.createentity{position={16,9602},name="planetmarket",force=game.player.force}
		glob.red_planet.valuables_market.addmarketitem{price={{"science-pack-1",128}}, offer={type="give-item", item="red-planet-point"}}
		glob.red_planet.valuables_market.addmarketitem{price={{"science-pack-2",64}}, offer={type="give-item", item="red-planet-point"}}
		glob.red_planet.valuables_market.addmarketitem{price={{"science-pack-3",8}}, offer={type="give-item", item="red-planet-point"}}
		glob.red_planet.valuables_market.addmarketitem{price={{"alien-science-pack",10}}, offer={type="give-item", item="red-planet-point"}}
		glob.red_planet.valuables_market.addmarketitem{price={{"coin",1}}, offer={type="give-item", item="light-oil-barrel"}}
		glob.red_planet.housing={}
		glob.red_planet.housing[1]=game.createentity{position={19,9602},name="house",force=game.player.force}
		glob.red_planet.housing[2]=game.createentity{position={22,9602},name="house",force=game.player.force}
		glob.red_planet.housing[3]=game.createentity{position={25,9602},name="house",force=game.player.force}
		glob.red_planet.housing[4]=game.createentity{position={12,9602},name="house",force=game.player.force}
		glob.red_planet.housing[5]=game.createentity{position={9,9602},name="house",force=game.player.force}
		glob.red_planet.housing[6]=game.createentity{position={6,9602},name="house",force=game.player.force}
		
		for xx=0,31 do 
			game.createentity{position={event.area.lefttop.x+xx,event.area.lefttop.y},name="red-stone-rock"}
		end
		for yy=0,31 do 
			game.createentity{position={event.area.lefttop.x,event.area.lefttop.y+yy},name="red-stone-rock"}
		end
		for xx=0,14 do 
			game.createentity{position={event.area.lefttop.x+xx,event.area.lefttop.y+31},name="red-stone-rock"}
		end
		for xx=18,31 do 
			game.createentity{position={event.area.lefttop.x+xx,event.area.lefttop.y+31},name="red-stone-rock"}
		end
		for yy=0,31 do 
			game.createentity{position={event.area.lefttop.x+32,event.area.lefttop.y+yy},name="red-stone-rock"}
		end
		local tiles={}
		for xx=0,31 do
			for yy=0,31 do
				table.insert(tiles, {position={event.area.lefttop.x+xx,event.area.lefttop.y+yy},name="floor"})
			end
		end
		game.settiles(tiles)
	end
end)
game.onevent(defines.events.onentitydied, function(event)
	if event.entity.name=="remote-controlled-robot" then
		
		if glob.player.valid then
			game.player.character=glob.player
			game.setgamestate{gamefinished=false, playerwon=false}
		end
	end

end)

game.onevent(defines.events.onguiclick, function(event)
	if event.element.name == "ClosePDA" then
		newmenu()
	elseif event.element.name == "Close" then
		Close()
	elseif event.element.name == "wireless" then
		wireless()
	elseif event.element.name == "ad" then
		add()
	elseif event.element.name == "substract" then
		substract()
	elseif event.element.name == "set" then
		setfreq()
	elseif event.element.name == "toggle" then
		togglefreq(tonumber(game.player.gui.left.menu.buttons.count.caption))
		checkrobot(tonumber(game.player.gui.left.menu.buttons.count.caption))
	elseif event.element.name == "missile" then
		missileboom()
	elseif event.element.name == "addrobot" then
		addrobot()
	elseif event.element.name == "substractrobot" then
		substractrobot()
	elseif event.element.name == "setrobot" then
		setrobot()
	elseif event.element.name == "exitplanets" then
		game.player.gui.center.planets.destroy()
	elseif event.element.name=="donelp" then
		donelp()
	elseif event.element.name == "red" and glob.planet~="red" then
		redplanet()
	elseif event.element.name == "earth" and glob.planet~="earth" then
		earthplanet()
	elseif event.element.name == "home" then
		homeplanet()
	elseif event.element.name == "refuel" then
		refuel()
	elseif event.element.name == "trading" then
		trading()
	elseif event.element.name == "close-trades" then
		closetrading()
	elseif event.element.name == "changeplatleft" then
		changeplatleft()
	elseif event.element.name == "changeplatright" then
		changeplatright()
	elseif event.element.name == "changetraderight" then
		changetraderight()
	elseif event.element.name == "changetradeleft" then
		changetradeleft()
	elseif event.element.name == "addamounttrade" then
		addtradeamount()
	elseif event.element.name == "subamounttrade" then
		subtradeamount()
	elseif event.element.name == "addamounttrade2" then
		addtradeamount2()
	elseif event.element.name == "subamounttrade2" then
		subtradeamount2()
	elseif event.element.name == "nilamounttrade" then
		nilamounttrade()
	end
end)


--functions--
function nilamounttrade()
	if glob.landingplatforms[glob.currenttradepage].tradeamount~=nil then
		glob.landingplatforms[glob.currenttradepage].tradeamount=nil
	end
	updatetrade()
end

function addtradeamount2()
	if glob.landingplatforms[glob.currenttradepage]~=nil and glob.landingplatforms[glob.currenttradepage].trade~=nil then
		if glob.landingplatforms[glob.currenttradepage].tradeamount==nil then
			glob.landingplatforms[glob.currenttradepage].tradeamount=10
		else
			glob.landingplatforms[glob.currenttradepage].tradeamount=glob.landingplatforms[glob.currenttradepage].tradeamount+10
		end
	end
	updatetrade()
end

function subtradeamount2()
	if glob.landingplatforms[glob.currenttradepage]~=nil and glob.landingplatforms[glob.currenttradepage].trade~=nil then
		if glob.landingplatforms[glob.currenttradepage].tradeamount~=nil and glob.landingplatforms[glob.currenttradepage].tradeamount<11 then
			glob.landingplatforms[glob.currenttradepage].tradeamount=nil				
		elseif glob.landingplatforms[glob.currenttradepage].tradeamount~=nil then
			glob.landingplatforms[glob.currenttradepage].tradeamount=glob.landingplatforms[glob.currenttradepage].tradeamount-10
		end
	end
	updatetrade()
end

function addtradeamount()
	if glob.landingplatforms[glob.currenttradepage]~=nil and glob.landingplatforms[glob.currenttradepage].trade~=nil then
		if glob.landingplatforms[glob.currenttradepage].tradeamount==nil then
			glob.landingplatforms[glob.currenttradepage].tradeamount=1
		else
			glob.landingplatforms[glob.currenttradepage].tradeamount=glob.landingplatforms[glob.currenttradepage].tradeamount+1
		end
	end
	updatetrade()
end

function subtradeamount()
	if glob.landingplatforms[glob.currenttradepage]~=nil and glob.landingplatforms[glob.currenttradepage].trade~=nil then
		if glob.landingplatforms[glob.currenttradepage].tradeamount~=nil and glob.landingplatforms[glob.currenttradepage].tradeamount==1 then
			glob.landingplatforms[glob.currenttradepage].tradeamount=nil
		elseif glob.landingplatforms[glob.currenttradepage].tradeamount~=nil then
			glob.landingplatforms[glob.currenttradepage].tradeamount=glob.landingplatforms[glob.currenttradepage].tradeamount-1
		end
	end
	updatetrade()
end

function updatetrade()
	game.player.gui.left.menu.vertical.horizontal1.nameplat.caption=glob.landingplatforms[glob.currenttradepage].name
	if glob.landingplatforms[glob.currenttradepage].trade~=nil then
		game.player.gui.left.menu.vertical.horizontal2.trade.caption=glob.planettrades.trades[glob.landingplatforms[glob.currenttradepage].trade].name
		game.player.gui.left.menu.vertical.horizontal3.tradedetails.caption=glob.planettrades.trades[glob.landingplatforms[glob.currenttradepage].trade].description
		if glob.landingplatforms[glob.currenttradepage].tradeamount==nil then
			game.player.gui.left.menu.vertical.horizontal4.tradeprice.caption="Amount: ---"
		else 
			game.player.gui.left.menu.vertical.horizontal4.tradeprice.caption="Amount: "..glob.landingplatforms[glob.currenttradepage].tradeamount
		end
	else
		game.player.gui.left.menu.vertical.horizontal2.trade.caption="---"
		game.player.gui.left.menu.vertical.horizontal3.tradedetails.caption="                                           ---"
	end
end

function changeplatright()
	if glob.currenttradepage<(#glob.landingplatforms) then
		glob.currenttradepage=glob.currenttradepage+1
	end
	updatetrade()
end

function changeplatleft()
	if glob.currenttradepage>1 then
		glob.currenttradepage=glob.currenttradepage-1
	end
	updatetrade()
end

function changetraderight()
	if glob.landingplatforms[glob.currenttradepage].trade~=nil then
		if glob.landingplatforms[glob.currenttradepage].trade<#glob.planettrades.trades then
			glob.landingplatforms[glob.currenttradepage].trade=glob.landingplatforms[glob.currenttradepage].trade+1
		end
		updatetrade()
	elseif glob.planettrades~=nil and glob.planettrades.trades~=nil and glob.planettrades.trades[1]~=nil then
		glob.landingplatforms[glob.currenttradepage].trade=1
		updatetrade()
	end
end

function changetradeleft()
	if glob.landingplatforms[glob.currenttradepage].trade~=nil then
		if glob.landingplatforms[glob.currenttradepage].trade>1 then
			glob.landingplatforms[glob.currenttradepage].trade=glob.landingplatforms[glob.currenttradepage].trade-1
		elseif glob.landingplatforms[glob.currenttradepage].trade==1 then
			glob.landingplatforms[glob.currenttradepage].trade=nil
			updatetrade()
		end
		updatetrade()
	end
end
function closetrading()
	
	Close()
end

function trading()
	if glob.landingplatforms==nil then
		game.player.print("You havent got any landing platforms to start trading.")
	elseif glob.landingplatforms[1]~=nil then
		newmenu()
		glob.currenttradepage=1
		game.player.gui.left.add{type="frame",name="menu",caption="Landing platforms trades"} 
		game.player.gui.left.menu.add{type="flow",name="vertical", direction="vertical"} 
		game.player.gui.left.menu.vertical.add{type="flow",name="horizontal1", direction="horizontal"} 
		game.player.gui.left.menu.vertical.add{type="flow",name="horizontal2", direction="horizontal"} 
		game.player.gui.left.menu.vertical.add{type="flow",name="horizontal3", direction="horizontal"} 
		game.player.gui.left.menu.vertical.add{type="flow",name="horizontal4", direction="horizontal"} 
		game.player.gui.left.menu.vertical.add{type="flow",name="horizontal5", direction="horizontal"} 
		game.player.gui.left.menu.vertical.horizontal1.add{type="button",caption="<", name="changeplatleft"} 
		game.player.gui.left.menu.vertical.horizontal1.add{type="button",caption=glob.landingplatforms[1].name, style="landing_platform_name_button_style",name="nameplat"} 
		game.player.gui.left.menu.vertical.horizontal1.add{type="button",caption=">", name="changeplatright"} 
		game.player.gui.left.menu.vertical.horizontal2.add{type="button",caption="<", name="changetradeleft"} 
		game.player.gui.left.menu.vertical.horizontal2.add{type="button",caption="---", name="trade",style="landing_platform_name_button_style"} 
		game.player.gui.left.menu.vertical.horizontal2.add{type="button",caption=">", name="changetraderight"}
		game.player.gui.left.menu.vertical.horizontal3.add{type="label",caption="---", name="tradedetails"}
		game.player.gui.left.menu.vertical.horizontal4.add{type="label",caption="---", name="tradeprice"}
		game.player.gui.left.menu.vertical.horizontal4.tradeprice.caption="Amount: ---"
		game.player.gui.left.menu.vertical.horizontal4.add{type="button",caption="  ++  ", name="addamounttrade2",style="addsub_button"}
		game.player.gui.left.menu.vertical.horizontal4.add{type="button",caption="  +  ", name="addamounttrade",style="addsub_button"}
		game.player.gui.left.menu.vertical.horizontal4.add{type="button",caption="  0  ", name="nilamounttrade",style="addsub_button"}
		game.player.gui.left.menu.vertical.horizontal4.add{type="button",caption="  -  ", name="subamounttrade",style="addsub_button"}
		game.player.gui.left.menu.vertical.horizontal4.add{type="button",caption="  --  ", name="subamounttrade2",style="addsub_button"}
		game.player.gui.left.menu.vertical.horizontal5.add{type="button",caption="Close", style="menu_button_style", name="close-trades"}
		updatetrade()
	end
end

function donelp()
	glob.landingplatforms[tonumber(string.sub(string.sub(game.player.gui.center.lpname.caption,23),-2,-2))].name=game.player.gui.center.lpname.lpnamebox.text
	game.player.print("The name has been set ("..glob.landingplatforms[tonumber(string.sub(string.sub(game.player.gui.center.lpname.caption,23),-2,-2))].name..")")
	game.player.gui.center.lpname.destroy()
	game.player.gui.center.add{type="flow",name="update"} 
	game.player.gui.center.update.destroy()
end

function earthplanet()
	game.player.print("Not in yet.")
--[[	if glob.currentrocket.fuel~=nil and glob.currentrocket.fuel>=8 then
		
		
		glob.planet="earth"
		game.player.gui.center.planets.destroy()
		-----Missing moving part
	end]]
end

function homeplanet()
	if game.player.character.name=="player" then
		if glob.currentrocket.fuel~=nil and glob.currentrocket.fuel>=8 and glob.planet~="home" then
			game.player.character.teleport{glob.currentrocket.entity.position.x,glob.currentrocket.entity.position.y+3}
			glob.currentrocket.fuel=glob.currentrocket.fuel-8
			if glob.planet=="earth" then
				for i,d in pairs(glob.currentrocket.earthrocket.getinventory(1).getcontents()) do
					glob.currentrocket.entity.insert{name=i,count=d}
				end
				glob.currentrocket.earthrocket.getinventory(1).clear()
			elseif glob.planet=="red" then
				for i,d in pairs(glob.currentrocket.redrocket.getinventory(1).getcontents()) do
					glob.currentrocket.entity.insert{name=i,count=d}
				end
				glob.currentrocket.redrocket.getinventory(1).clear()
			end
			glob.planet="home"
			game.player.gui.center.planets.destroy()
			game.player.zoom=1
			for x=-128,128,8 do 
				for y=-128,128,8 do 
					for i=1,20 do 
						game.createentity({name="black-screen", position={game.player.character.position.x+x,game.player.character.position.y+y}}) 
					end 
				end 
			end 
		end
	else
		game.player.print("A robot doesn't know how to control a rocket!")
	end
end

function refuel()
	if glob.planet=="earth" then
		rocketinplanet=glob.currentrocket.earthrocket
	elseif glob.planet=="red" then
		rocketinplanet=glob.currentrocket.redrocket
	elseif glob.planet=="home" then
		rocketinplanet=glob.currentrocket.entity
	end
	if glob.currentrocket.fuel==nil then
		glob.currentrocket.fuel=0
	end	
	if rocketinplanet.getinventory(1).getitemcount("light-oil-barrel")~=0 then
		if (glob.currentrocket.fuel+rocketinplanet.getinventory(1).getitemcount("light-oil-barrel"))<40 then
			
			glob.currentrocket.fuel=(glob.currentrocket.fuel+rocketinplanet.getinventory(1).getitemcount("light-oil-barrel"))
			local barrels = rocketinplanet.getinventory(1).getitemcount("light-oil-barrel")
			rocketinplanet.getinventory(1).remove{name="light-oil-barrel", count=barrels}
			rocketinplanet.getinventory(1).insert{name="empty-barrel", count=barrels}
			game.player.gui.center.planets.vert.hori3.fuel.value=(glob.currentrocket.fuel/40)
		elseif glob.currentrocket.fuel~=40 then
			rocketinplanet.getinventory(1).remove{name="light-oil-barrel", count=(40-glob.currentrocket.fuel)}
			rocketinplanet.getinventory(1).insert{name="empty-barrel", count=(40-glob.currentrocket.fuel)}
			glob.currentrocket.fuel=40
			game.player.gui.center.planets.vert.hori3.fuel.value=(glob.currentrocket.fuel/40)
		end
	end
end

function redplanet()
	if game.player.character.name=="player" then
		if glob.currentrocket.fuel~=nil and glob.currentrocket.fuel>=16 then
			if glob.currentrocket.redrocket==nil then
				glob.currentrocket.redrocket=game.createentity{position={7,9625},name="rocket-5",force=game.player.force}
				glob.currentrocket.redrocket.destructible=false
				glob.currentrocket.redrocket.minable=false
			end
			game.player.character.teleport{glob.currentrocket.redrocket.position.x,glob.currentrocket.redrocket.position.y+3}
			glob.currentrocket.fuel=glob.currentrocket.fuel-8
			if glob.planet=="earth" then
				for i,d in pairs(glob.currentrocket.earthrocket.getinventory(1).getcontents()) do
					glob.currentrocket.redrocket.insert{name=i,count=d}
				end
				glob.currentrocket.earthrocket.getinventory(1).clear()
			elseif glob.planet=="home" then
				for i,d in pairs(glob.currentrocket.entity.getinventory(1).getcontents()) do
					glob.currentrocket.redrocket.insert{name=i,count=d}
				end
				glob.currentrocket.entity.getinventory(1).clear()
			end
			glob.planet="red"
			game.player.gui.center.planets.destroy()
			game.player.zoom=1
			for x=-128,128,8 do 
				for y=-128,128,8 do 
					for i=1,20 do 
						game.createentity({name="black-screen", position={game.player.character.position.x+x,game.player.character.position.y+y}}) 
					end 
				end 
			end 
		elseif glob.currentrocket.fuel~=nil and glob.currentrocket.fuel>=8 then
			game.player.print("You wont have enough fuel to go back home.")
		end
	else
		game.player.print("A robot doesn't know how to control a rocket!")
	end
end

function tequals(table1, table2)
	local result=true
	for i,x in pairs(table1) do
		if table1[i]~=table2[i] then
			result=false
		end
	end
	return result
end

function togglefreq(freq)
	if glob.wireless.frequencies[freq]~=nil then
		for i,x in pairs(glob.wireless.frequencies[freq]) do
			if type(x)~="boolean" and x.valid then
				if glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active then
					glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active = false
					game.player.gui.left.menu.secondflow.Active.caption=tostring(glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active)
				else
					glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active = true
					game.player.gui.left.menu.secondflow.Active.caption=tostring(glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active)
				end
				local entities=game.findentities({{x.position.x-1,x.position.y-1},{x.position.x+1,x.position.y+1}})
				for y,z in pairs(entities) do
					if z.name~="player" then
						z.active=glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active
					end
					if z.name~="player" and z.name~="door-closed" and z.name~="door-opened" then
						z.active=glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active
					elseif z.name=="door-closed" and glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active then
						local ent=game.createentity({name="door-opened",position=z.position})
						ent.health=z.health
						z.destroy()
					elseif z.name=="door-opened" and glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active==false then
						ent=game.createentity({name="door-closed",position=z.position})
						ent.health=z.health
						z.destroy()
					end
				end
			elseif type(x)~="boolean" then
				table.remove(glob.wireless.frequencies[freq],i)
			end
		end
	end
end

function setfreq()
	if glob.forsure==true then
		if game.player.getinventory(2).getitemcount("electronic-circuit")>=1 and game.player.getinventory(2).getitemcount("soldering-tin")>=3 then
			game.player.getinventory(2).remove({name="electronic-circuit",count=1})
			game.player.getinventory(2).remove({name="soldering-tin",count=3})
			for z,y in pairs(glob.wireless.frequencies) do
				for o,entity in pairs(glob.wireless.frequencies[z]) do
					if type(entity)~="boolean" and entity.valid and entity.position.x==glob.selectedsoldering.position.x and entity.position.y==glob.selectedsoldering.position.y then
						table.remove(glob.wireless.frequencies[z],o)
					end
				end
			end
			if glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)]==nil then
				glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)]={}
				glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active=true
			end
			game.player.print("Frequency has been set")
			table.insert(glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)],glob.selectedsoldering)
			newmenu()
			glob.forsure=false
		else
			game.player.print("You haven't got enough materials")
			glob.forsure=false
		end
	else
		glob.forsure=true
		game.player.print("You will use one electronic circuit and three soldering tin. Press again to confirm.")
	end
end

function extendsoldering()
	glob.forsure=false
	glob.selectedsoldering=game.player.selected
	if glob.selectedsoldering~=nil and glob.selectedsoldering.valid then
		if glob.selectedsoldering.name=="wireless-base" then
			if game.player.gui.left.menu~=nil then
				newmenu()
			end
			game.player.gui.left.add({type="frame", name="menu", caption="Change frequency",direction="vertical",style="soldering_iron"})
			game.player.gui.left.menu.add({type="flow",name="buttons",direction="horizontal"})
			game.player.gui.left.menu.buttons.add({type="button", name="ad", caption=" + ",style="transparent_button"})
			game.player.gui.left.menu.buttons.ad.style.minimalheight=50
			game.player.gui.left.menu.buttons.ad.style.minimalwidth=40
			game.player.gui.left.menu.buttons.add({type="button", name="count", caption="1",style="transparent_button"})
			game.player.gui.left.menu.buttons.count.style.minimalwidth=204
			game.player.gui.left.menu.buttons.add({type="button", name="substract", caption=" - ",style="transparent_button"})
			game.player.gui.left.menu.buttons.substract.style.minimalheight=50
			game.player.gui.left.menu.buttons.substract.style.minimalwidth=40
			game.player.gui.left.menu.add({type="flow",name="secondflow",direction="vertical"})
			game.player.gui.left.menu.secondflow.add({type="button", name="set", caption="Set",style="transparent_button"})
			game.player.gui.left.menu.secondflow.add({type="button", name="ClosePDA", caption="Close",style="transparent_button"})
		elseif glob.selectedsoldering.name=="remote-controlled-robot" then
			if game.player.gui.left.menu~=nil then
				newmenu()
			end
				game.player.gui.left.add({type="frame", name="menu", caption="Change frequency",direction="vertical",style="soldering_iron"})
				game.player.gui.left.menu.add({type="flow",name="buttons",direction="horizontal"})
				game.player.gui.left.menu.buttons.add({type="button", name="addrobot", caption=" + ",style="transparent_button"})
				game.player.gui.left.menu.buttons.addrobot.style.minimalheight=50
				game.player.gui.left.menu.buttons.addrobot.style.minimalwidth=40
				game.player.gui.left.menu.buttons.add({type="button", name="countrobot", caption="1",style="transparent_button"})
				game.player.gui.left.menu.buttons.countrobot.style.minimalwidth=204
				game.player.gui.left.menu.buttons.add({type="button", name="substractrobot", caption=" - ",style="transparent_button"})
				game.player.gui.left.menu.buttons.substractrobot.style.minimalheight=50
				game.player.gui.left.menu.buttons.substractrobot.style.minimalwidth=40
				game.player.gui.left.menu.add({type="flow",name="secondflow",direction="vertical"})
				game.player.gui.left.menu.secondflow.add({type="button", name="setrobot", caption="Set",style="transparent_button"})
				game.player.gui.left.menu.secondflow.add({type="button", name="ClosePDA", caption="Close",style="transparent_button"})
		end
	end
end

function addrobot()
	glob.forsure=false
	if tonumber(game.player.gui.left.menu.buttons.countrobot.caption)<100 then
		game.player.gui.left.menu.buttons.countrobot.caption=game.player.gui.left.menu.buttons.countrobot.caption+1
	end
end
function substractrobot()
	glob.forsure=false
	if tonumber(game.player.gui.left.menu.buttons.countrobot.caption)>1 then
		game.player.gui.left.menu.buttons.countrobot.caption=game.player.gui.left.menu.buttons.countrobot.caption-1
	end
end
function setrobot()
	if glob.wireless.frequencies[game.player.gui.left.menu.buttons.countrobot.caption]==nil then
		glob.wireless.frequencies[game.player.gui.left.menu.buttons.countrobot.caption]={}
		glob.wireless.frequencies[game.player.gui.left.menu.buttons.countrobot.caption].active=true
	end
	if game.player.getinventory(2).getitemcount("electronic-circuit")>=1 and game.player.getinventory(2).getitemcount("soldering-tin")>=3 then
		game.player.getinventory(2).remove({name="electronic-circuit",count=1})
		game.player.getinventory(2).remove({name="soldering-tin",count=3})
		if glob.robots==nil then
			glob.robots={}
		end
		table.insert(glob.robots,{entity=glob.selectedsoldering, frequency=game.player.gui.left.menu.buttons.countrobot.caption})
		newmenu()
	else
		game.player.print("You haven't got enough material")
	end
end

function add()
	glob.forsure=false
	if tonumber(game.player.gui.left.menu.buttons.count.caption)<100 then
		game.player.gui.left.menu.buttons.count.caption=game.player.gui.left.menu.buttons.count.caption+1
		if game.player.gui.left.menu.secondflow.Active~=nil and glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)]~=nil then
			game.player.gui.left.menu.secondflow.Active.caption=tostring(glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active)
		elseif game.player.gui.left.menu.secondflow.Active~=nil then
			game.player.gui.left.menu.secondflow.Active.caption="None"
		end
	end
end
function substract()
	glob.forsure=false
	if tonumber(game.player.gui.left.menu.buttons.count.caption)>1 then
		game.player.gui.left.menu.buttons.count.caption=game.player.gui.left.menu.buttons.count.caption-1
		if game.player.gui.left.menu.secondflow.Active~=nil and glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)]~=nil then
			game.player.gui.left.menu.secondflow.Active.caption=tostring(glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active)
		elseif game.player.gui.left.menu.secondflow.Active~=nil then
			game.player.gui.left.menu.secondflow.Active.caption="None"
		end
	end
end
function wireless()
	newmenu()
	game.player.gui.left.add({type="frame", name="menu", caption="Wireless",direction="vertical"})
	game.player.gui.left.menu.add({type="flow",name="buttons",direction="horizontal"})
	game.player.gui.left.menu.buttons.add({type="button", name="ad", caption=" + ",style="menu_button_style"})
	game.player.gui.left.menu.buttons.ad.style.minimalheight=50
	game.player.gui.left.menu.buttons.ad.style.minimalwidth=40
	game.player.gui.left.menu.buttons.add({type="button", name="count", caption="1",style="menu_button_style"})
	game.player.gui.left.menu.buttons.count.style.minimalwidth=204
	game.player.gui.left.menu.buttons.add({type="button", name="substract", caption=" - ",style="menu_button_style"})
	game.player.gui.left.menu.buttons.substract.style.minimalheight=50
	game.player.gui.left.menu.buttons.substract.style.minimalwidth=40
	game.player.gui.left.menu.add({type="flow",name="secondflow",direction="vertical"})
	game.player.gui.left.menu.secondflow.add({type="button", name="toggle", caption="Toggle",style="menu_button_style"})
	if glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)]~=nil then
		game.player.gui.left.menu.secondflow.add({type="button", name="Active", caption=tostring(glob.wireless.frequencies[tonumber(game.player.gui.left.menu.buttons.count.caption)].active) ,style="menu_button_style"})
	else
		game.player.gui.left.menu.secondflow.add({type="button", name="Active", caption="None",style="menu_button_style"})
	end
	game.player.gui.left.menu.secondflow.add({type="button", name="Close", caption="Close",style="menu_button_style"})
end

function newmenu()
	game.player.gui.left.menu.destroy()
end


function extend()
	game.player.gui.left.add({ type="frame", name="menu", caption="PDA", direction="vertical"})
	game.player.gui.left.menu.add({ type="button", name="wireless", caption="Wireless",style="menu_button_style"})
	game.player.gui.left.menu.add({ type="button", name="trading", caption="Trading",style="menu_button_style"})
	game.player.gui.left.menu.add({ type="button", name="ClosePDA", caption="Close",style="menu_button_style"})
end

function Close()
	newmenu()
	extend()
end

function missile()
	turnonmissile=true
end

function missileboom()
	if glob.missile==true then
		glob.missile=false
		glob.missilecount=1
		game.createentity({name="huge-explosion",position=glob.dynamite[i].entity.position})
		posi=game.player.position
		for pos=0,10,2.5 do
			local entities=game.findentities({{posi.x-pos,posi.y-pos},{posi.x+pos,posi.y+pos}})
			for i,_ in pairs(entities) do
				if entities[i].health~=nil then
					entities[i].damage(50,game.player.force)
				elseif entities[i].name=="iron-ore" or entities[i].name=="copper-ore" or entities[i].name=="coal" or entities[i].name=="stone" then
					entities[i].amount=entities[i].amount-1
					game.createentity{name="item-on-ground", position=entities[i].position, stack={name=entities[i].name}}
					if entities[i].amount<=0 then
						entities[i].destroy()
					end
				end
			end
		end
	end
end

function checkrobot(freq)
	if glob.player==nil then
		glob.player=game.player.character
	end
	if glob.controllerfreq==nil then
		glob.controllerfreq=0
	end
	if game.player.character~=nil and game.player.character.name=="player" then
		if glob.robots~=nil then
			for i,d in pairs(glob.robots) do
				if tonumber(d.frequency)==tonumber(freq) then
					if glob.player~=nil and glob.player.valid then
						game.player.character=d.entity
						glob.controllerfreq=tonumber(freq)
					else
						game.setgamestate{gamefinished=true, playerwon=false}
					end
				end
			end
		end
	elseif game.player.character~=nil then
		if tonumber(glob.controllerfreq)==tonumber(freq) then
			if glob.player~=nil and glob.player.valid then
				game.player.character=glob.player
			else
				game.setgamestate{gamefinished=true, playerwon=false}
			end
		else
			for i,d in pairs(glob.robots) do
				if tonumber(d.frequency)==tonumber(freq) then
					if glob.player~=nil and glob.player.valid then
						game.player.character=d.entity
						glob.controllerfreq=tonumber(freq)
						
					else
						game.setgamestate{gamefinished=true, playerwon=false}
					end
				end
			end
		end
	end
end