
data:extend({
	
	{
    type = "fluid",
    name = "water-hot",
    default_temperature = 100,
    max_temperature = 100,
    heat_capacity = "1KJ",
    base_color = {r=0, g=0, b=1},
    flow_color = {r=0.7, g=0.7, b=0.7},
    icon = "__base__/graphics/icons/fluid/water.png",
    order = "a[fluid]-a[water]",
    pressure_to_speed_ratio = 0.4,
    flow_to_energy_ratio = 0.59,
  },
  {
    type = "mining-drill",
    name = "geotermal-station",
    icon = "__base__/graphics/icons/pumpjack.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "geotermal-station"},
    resource_categories = {"hot-water"},
    max_health = 100,
    corpse = "big-remnants",
    collision_box = {{ -1.4, -1.4}, {1.4, 1.4}},
    selection_box = {{ -1.5, -1.5}, {1.5, 1.5}},
    drawing_box = {{-1.6, -2.5}, {1.5, 1.6}},
    energy_source =
    {
      type = "electric",
      emissions = 0,
      usage_priority = "secondary-input"
    },
    fluid_box =
    {
      base_area = 1,
      pipe_covers = pipecoverspictures(),
      pipe_connections =
      {
        {
          positions = { {1, -2}, {2, -1}, {-1, 2}, {-2, 1} }
        }
      },
    },
    energy_usage = "90kW",
    mining_speed = 1,
    mining_power = 2,
    resource_searching_radius = 0.49,
    vector_to_place_result = {0, 0},
    module_slots = 2,
    radius_visualisation_picture =
    {
      filename = "__base__/graphics/entity/pumpjack/pumpjack-radius-visualization.png",
      width = 12,
      height = 12
    },
    base_picture =
    {
      sheet = "__base__/graphics/entity/pumpjack/pumpjack-base.png",
      priority = "extra-high",
      width = 114,
      height = 113,
      shift = {0.1875, -0.03125}
    },
    animations =
    {
      north =
      {
        priority = "extra-high",
        width = 116,
        height = 110,
        line_length = 10,
        shift = {0.125, -0.71875},
        filename = "__base__/graphics/entity/pumpjack/pumpjack-animation.png",
        frame_count = 40,
        animation_speed = 0.5
      }
    }
  },
    {
    type = "resource-category",
    name = "hot-water"
  },
  {
    type = "resource",
    name = "geiser",
    icon = "__F-mod__/resources/icons/geyser.png",
    flags = {"placeable-neutral"},
    category = "hot-water",
    order="a-b-a",
    infinite = true,
    minimum = 7500000000,
    normal = 7500000000,
    minable =
    {
      hardness = 1,
      mining_time = 1,
      results =
      {
        {
          type = "fluid",
          name = "water-hot",
          amount_min = 1,
          amount_max = 1,
          probability = 1
        }
      }
    },
    collision_box = {{ -1.4, -1.4}, {1.4, 1.4}},
    selection_box = {{ -0.5, -0.5}, {0.5, 0.5}},
    autoplace =
    {
      control = "geiser",
      sharpness = 1,
      max_probability = 0.04,
      richness_multiplier = 5000000,
      richness_base = 5000000,
      peaks =
      {
        {
          influence = 0.1
        },
        {
          influence = 0.105,
          starting_area_weight_optimal = 1,
          starting_area_weight_range = 0,
          starting_area_weight_max_range = 2,
        },
        {
          influence = 0.67,
          noise_layer = "geyser",
          noise_octaves_difference = -2.7,
          noise_persistence = 0.3
        }
      }
    },
    stage_counts = {0},
    stages =
    {
      filename= "__F-mod__/resources/entity/geiser/geyser.png",
      priority = "extra-high",
      width = 75,
      height = 61,
      frame_count = 4,
      direction_count = 1
    },
    map_color = {r=0.5, g=0.5, b=1},
    map_grid = false
  },
  
    {
    type = "autoplace-control",
    name = "geiser",
    richness = true,
    order = "b-f"
  },
   {
    type = "noise-layer",
    name = "geyser",
  },
   {
    type = "item",
    name = "geotermal-station",
    icon = "__base__/graphics/icons/pumpjack.png",
    flags = {"goes-to-quickbar"},
    subgroup = "energy",
    order = "b",
    place_result = "geotermal-station",
    stack_size = 64
  }
})