require "util"


data:extend(
{

	  {
   	type = "recipe",
   	name =  "remote-controlled-robot",
   	result= "remote-controlled-robot",
   	ingredients= { {"anten", 1}, {"aluminium-plate", 100 }, {"iron-plate", 100}, {"copper-cable", 50},{"speed-module-3",1}},
	energy_required= 10,
    enabled= "false",
	category= "crafting"
  },
  {
	type="item",
	name = "remote-controlled-robot",
    icon = "__F-mod__/resources/icons/remote-controlled-robot.png",
    flags = {"goes-to-quickbar"},
    subgroup = "logistic-network",
    order = "l-r",
    place_result = "remote-controlled-robot",
    stack_size = 1
  },
  {
    type = "player",
	collision_mask="stringinhere",
	render_layer="wires",
	final_render_layer = "wires",
    name = "remote-controlled-robot",
    icon = "__base__/graphics/icons/logistic-robot.png",
    flags = {"placeable-player", "placeable-off-grid"},
	mining_categories = {"basic-solid"},
    max_health = 100,
    healing_per_tick = 0.01,
    collision_box = {{-0.4, -0.4}, {0.4, 0.4}},
    selection_box = {{-0.4, -0.4}, {0.4, 0.4}},
    crafting_categories = {"robot"},
    inventory_size = 10,
	build_distance = 2,
    drop_item_distance = 2,
    reach_distance = 2,
    reach_resource_distance = 0.3,
    ticks_to_keep_gun = 600,
    ticks_to_keep_aiming_direction = 100,
    damage_hit_tint = {r = 1, g = 0, b = 0, a = 0},
    running_speed = 0.15,
    distance_per_frame = 0.13,
    maximum_corner_sliding_distance = 0.7,
    order="a",
    eat =
    {
      {
        filename = "__base__/sound/eat.ogg",
        volume = 0
      }
    },
    heartbeat =
    {
      {
        filename = "__base__/sound/heartbeat.ogg",
        volume = 0
      }
    },
    animations =
    {
	  level1 =
	  {
	    idle =
		{
          priority = "medium",
          width = 48,
          height = 66,
          direction_count = 5,
          frame_count = 3,
          stripes =
          {
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            },
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            },
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            }
          },
          shift = {0, -0.5}
        },
	    idle_with_gun =
        {
          priority = "medium",
          width = 48,
          height = 66,
          direction_count = 5,
          frame_count = 3,
          stripes =
          {
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            },
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            },
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            }
          },
          shift = {0, -0.5}
        },
		mining_with_hands =
        {
          priority = "medium",
          width = 48,
          height = 66,
          direction_count = 5,
          frame_count = 2,
          stripes =
          {
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            },
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            }
          },
          shift = {0, -0.5}
        },
		mining_with_tool =
        {
          priority = "medium",
          width = 48,
          height = 66,
          direction_count = 5,
          frame_count = 2,
          stripes =
          {
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            },
            {
              filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
              width_in_frames = 1
            }
          },
          shift = {0, -0.5}
        },
		running_with_gun =
		{
		  filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
		  priority = "medium",
		  width = 48,
		  height = 66,
		  frame_count = 1,
		  direction_count = 5,
		  shift = {0, -0.5}
		},
		running =
        {
          filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
          priority = "medium",
          width = 48,
          height = 66,
          frame_count = 1,
          direction_count = 5,
          shift = {0, -0.5}
        },
        runningmask =
        {
          filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
          priority = "medium",
          width = 48,
          height = 66,
          frame_count = 1,
          direction_count = 5,
          shift = {0, -0.5}
        },
	  },
	},
    light =
    {
      {
        minimum_darkness = 0.3,
        intensity = 0.4,
        size = 25,
      },
      {
        type = "oriented",
        minimum_darkness = 0.3,
        picture =
        {
          filename = "__core__/graphics/light-cone.png",
          priority = "medium",
          scale = 2,
          width = 200,
          height = 200
        },
        shift = {0, -13},
        size = 2,
        intensity = 0.6
      },
    },
    mining_speed = 0.01,
    mining_with_hands_particles_animation_positions = {29, 63},
    mining_with_tool_particles_animation_positions = {28},
    running_aim =
    {
      filename = "__F-mod__/resources/entity/remote-controlled-robot/remote-controlled-robot.png",
      priority = "medium",
      width = 48,
      height = 66,
      frame_count = 1,
      direction_count = 5,
      shift = {0, -0.5}
    },
    running_sound_animation_positions = {14, 29}
  },
  }
)
