require "util"

laser_turret_extension =
{
  filename = "__F-mod__/resources/entity/blank/blank.png",
  priority = "medium",
  width = 1,
  height = 1,
  direction_count = 1,
  frame_count = 1,
  axially_symmetrical = false,
  shift = {0, 0}
}

data:extend({
	{
	type = "technology",
    name= "turret-car",
    prerequisites= {"automobilism"},
	icon="__F-mod__/resources/technology/icons/turret-car.png",
    unit=
    {
      count= 50,
      time= 15,
      ingredients= { {"science-pack-1", 2}, {"science-pack-2", 2,}, {"science-pack-3", 1} }
    },
    effects=
    {
      {
        type= "unlock-recipe",
        recipe= "turret-car"
      },
    }
	},
	{
   	type = "recipe",
   	name =  "turret-car",
   	result= "turret-car",
   	ingredients= { {"car", 1}, {"laser-turret", 1 }},
	energy_required= 10,
    enabled= "false",
	subgroup= "transport"
  },
	{
		type="item",
		name = "car-turret",
		icon = "__base__/graphics/icons/car.png",
		flags = {"goes-to-quickbar"},
		order = "z-z-z",
		subgroup="transport",
		place_result = "car-turret",
		stack_size = 64
	},
	{
	type="item",
	name = "turret-car",
    icon = "__base__/graphics/icons/car.png",
    flags = {"goes-to-quickbar"},
    order = "c-t",
	group="combat",
    place_result = "turret-car",
    stack_size = 64
	},
  {
    type = "electric-turret",
    name = "car-turret",
	collision_mask="nope",
    icon = "__base__/graphics/icons/laser-turret.png",
    flags = { "placeable-player", "placeable-enemy", "player-creation","placeable-off-grid"},
    minable = { mining_time = 0.5},
    max_health = 250,
	order="z-z-z",
    corpse = "small-remnants",
    collision_box = {{0, 0}, {0, 0}},
    selection_box = {{ 0, 0}, {0, 0}},
    rotation_speed = 0.01,
    preparing_speed = 0.05,
    dying_explosion = "huge-explosion",
    folding_speed = 0.05,
    energy_source =
    {
      type = "electric",
      buffer_capacity = "201J",
      input_flow_limit = "1200W",
      resting_consumption_ratio = 0.01,
      usage_priority = "secondary-input",
    },
    folded_animation = (function()
                          local res = util.table.deepcopy(laser_turret_extension)
                          res.frame_count = 1
                          res.line_length = 1
                          return res
                       end)(),
    preparing_animation = laser_turret_extension,
    prepared_animation =
    {
      filename = "__F-mod__/resources/entity/blank/blank.png",
      priority = "medium",
      width = 1,
      height = 1,
      direction_count = 1,
      frame_count = 1,
      line_length = 1,
      axially_symmetrical = false,
      shift = {0, 0}
    },
    folding_animation = (function()
                          local res = util.table.deepcopy(laser_turret_extension)
                          res.run_mode = "backward"
                          return res
                       end)(),
    base_picture =
    {
      filename = "__F-mod__/resources/entity/blank/blank.png",
      priority = "high",
      width = 1,
      height = 1,
      shift = { 0, 0 }
    },
    attack_parameters =
    {
      ammo_category = "electric",
      cooldown = 20,
      damage = 2,
      projectile_center = {0, 0},
      projectile_creation_distance = 0.6,
      range = 25,
	  ammo_type =
      {
        type = "projectile",
        category = "laser-turret",
        energy_consumption = "0J",
        action =
        {
          {
            type = "direct",
            action_delivery =
            {
              {
                type = "projectile",
                projectile = "laser",
                starting_speed = 0.28
              }
            }
          }
        }
      },
      sound =
      {
        {
          filename = "__base__/sound/laser.ogg",
          volume = 0.4
        }
      }
    }
  },
    {
    type = "car",
    name = "turret-car",
    icon = "__base__/graphics/icons/car.png",
    flags = {"pushable", "placeable-neutral", "player-creation", "placeable-off-grid"},
    minable = {mining_time = 1, result = "turret-car"},
    max_health = 500,
    corpse = "medium-remnants",
	dying_explosion = "huge-explosion",
	energy_per_hit_point = 1,
    resistances = 
    {
      {
        type = "fire",
        percent = 50
      }
    },
    collision_box = {{-0.7, -1}, {0.7, 1}},
    selection_box = {{-0.7, -1}, {0.7, 1}},
	effectivity = 0.5,
	braking_power = "200kW",
    --acceleration_per_energy = 0.000001,
    --breaking_speed = 0.01,
    burner =
    {
      effectivity = 1,
      fuel_inventory_size = 1,
      smoke =
      {
        {
          name = "smoke",
          deviation = {0.25, 0.25},
          frequency = 50,
          position = {0, 1.5},
          slow_down_factor = 0.9,
          starting_frame = 3,
          starting_frame_deviation = 5,
          starting_frame_speed = 0,
          starting_frame_speed_deviation = 5
        }
      }
    },
    consumption = "800kW",
    friction = 0.02,
    light =
    {
      {
        type = "oriented",
        minimum_darkness = 0.3,
        picture =
        {
          filename = "__core__/graphics/light-cone.png",
          priority = "medium",
          scale = 2,
          width = 200,
          height = 200
        },
        shift = {-0.6, -14},
        size = 2,
        intensity = 0.6
      },
      {
        type = "oriented",
        minimum_darkness = 0.3,
        picture =
        {
          filename = "__core__/graphics/light-cone.png",
          priority = "medium",
          scale = 2,
          width = 200,
          height = 200
        },
        shift = {0.6, -14},
        size = 2,
        intensity = 0.6
      }
    },
    animation =
    {
	  layers =
	  {
	    {
          animation_speed = 8,
          width = 102,
          height = 86,
	      frame_count = 2,
          shift={0, -0.1875},
          axially_symmetrical = false,
          direction_count = 64,
		  max_advance = 0.2,
		  stripes =
		  {
		    {
			 filename = "__base__/graphics/entity/car/car-1.png",
			 width_in_frames = 2,
			 height_in_frames = 22,
			},
			{
			 filename = "__base__/graphics/entity/car/car-2.png",
			 width_in_frames = 2,
			 height_in_frames = 22,
			},
			{
			 filename = "__base__/graphics/entity/car/car-3.png",
			 width_in_frames = 2,
			 height_in_frames = 20,
			},
		  }
        },
--[[		{
		  width = 100,
		  height = 75,
		  frame_count = 2,
		  apply_runtime_tint = true,
		  axially_symmetrical = false,
		  direction_count = 64,
		  max_advance = 0.2,
		  line_length = 2,
		  shift = {0, -0.171875},
		  stripes = util.multiplayerstripes(2,
		  {
		    {
			  filename = "__base__/graphics/entity/car/car-mask-1.png",
			  width_in_frames = 1,
			  height_in_frames = 22,
			},
			{
			  filename = "__base__/graphics/entity/car/car-mask-2.png",
			  width_in_frames = 1,
			  height_in_frames = 22,
			},
			{
			  filename = "__base__/graphics_entity/car/car-mask-3.png",
			  width_in_frames = 1,
			  height_in_frames = 20,
			},
		  })
		},
		{
		  width = 114,
          height = 76,
          frame_count = 2,
          draw_as_shadow = true,
          axially_symmetrical = false,
          direction_count = 64,
          shift = {0.28125, 0.25},
          max_advance = 0.2,
          stripes = util.multiplystripes(2,
          {
           {
            filename = "__base__/graphics/entity/car/car-shadow-1.png",
            width_in_frames = 1,
            height_in_frames = 22,
           },
           {
            filename = "__base__/graphics/entity/car/car-shadow-2.png",
            width_in_frames = 1,
            height_in_frames = 22,
           },
           {
            filename = "__base__/graphics/entity/car/car-shadow-3.png",
            width_in_frames = 1,
            height_in_frames = 20,
           },
          })
        }]]
      }
    },
	stop_trigger_speed = 0.2,
	stop_trigger =
	{
	  {
	    type = "play-sound",
		sound =
		{
		  {
		    filename = "__base__/sound/car-breaks.ogg",
			volume = 0.6
		  },
		}
	  },
	},
	crash_trigger = crash_trigger(),
	sound_minimum_speed = 0.2;
	working_sound =
	{
	  sound =
	  {
	    filename = "__base__/sound/car-engine.ogg",
		volume = 0.6
	  },
	  activate_sound =
	  {
	    filename = "__base__/sound/car-engine-start.ogg",
		volume = 0.6
	  },
	  deactivate_sound =
	  {
	    filename = "__base__/sound/car-engine-stop.ogg",
		volume = 0.6
	  },
	  match_speed_to_activity = true,
	},
	open_sound = { filename = "__base__/sound/car-door-open.ogg", volume=0.7 },
	close_sound = { filename = "__base__/sound/car-door-close.ogg", volume=0.7 },
    rotation_speed = 0.015,
    weight = 700,
    inventory_size = 80
  },
  {
    type = "container",
    name = "iron-chest",
    icon = "__base__/graphics/icons/iron-chest.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "iron-chest"},
    max_health = 100,
    corpse = "small-remnants",
    resistances = 
    {
      {
        type = "fire",
        percent = 80
      }
    },
    collision_box = {{-0.4, -0.4}, {0.4, 0.4}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
    fast_replaceable_group = "container",
    inventory_size = 32,
    picture =
    {
      filename = "__base__/graphics/entity/iron-chest/iron-chest.png",
      priority = "extra-high",
      width = 48,
      height = 34,
      shift = {0.2, 0}
    }
  },
  }
)
