data:extend({

   {
    type = "unit-spawner",
    name = "house",
	order="h-u-s",
    icon = "__base__/graphics/icons/biter-spawner.png",
    flags = {"placeable-player", "placeable-neutral","placeable-enemy"},
    minable = {mining_time = 99999999, result = "raw-wood"},
    max_health = 600,
    resistances =
    {
      {
        type = "physical",
        decrease = 2,
      },
      {
        type = "explosion",
        decrease = 5,
        percent = 15,
      }
    },
    healing_per_tick = 0.02,
    collision_box = {{-2, -2}, {1, 2}},
    selection_box = {{-2, -2}, {1, 2}},
    pollution_cooldown = 10,
    max_count_of_owned_units = 1,
	max_friends_around_to_spawn = 1,
    animations ={
    {
      width = 128,
      height = 128,
      frame_count = 1,
      animation_speed = 1,
      run_mode = "forward-then-backward",
      axially_symmetric = false,
      direction_count = 1,
      shift = {0, 0},
      stripes =
      {
	   {
        filename = "__F-mod__/resources/entity/planet-buildings/house.png",
        width_in_frames = 1,
        height_in_frames = 1,
       },
	   {
        filename = "__F-mod__/resources/entity/planet-buildings/house.png",
        width_in_frames = 1,
        height_in_frames = 1,
       }
      }}
    },
    result_units = { {"person", 0.3} },
    spawning_cooldown = {99999999999, 99999999999},
    spawning_radius = 5,
    spawning_spacing = 1,
    max_spawn_shift = 0.65,
    max_richness_for_spawn_shift = 100,
    
    },

  
  
  -- Soldier:
  
  
    {
    type = "unit",
    name = "person",
	order="u-p",
    icon = "__base__/graphics/icons/creeper.png",
    flags = {"placeable-player","placeable-neutral", "placeable-enemy", "placeable-off-grid", "breaths-air"},
    max_health = 100,
	healing_per_tick = 0.02,
    collision_box = {{-0.2, -0.4}, {0.2, 0}},
    selection_box = {{-0.7, -1.5}, {0.7, 0.3}},
	sticker_box = {{-0.3, -0.5}, {0.3, 0.1}},
	distraction_cooldown = 300,
	vision_distance=30,
     attack_parameters =
    {
 --     ammo_category = "electric",
      cooldown = 20,
      damage = 5,
      projectile_center = {0, 0.4},
      projectile_creation_distance = 0.6,
      range = 20,
      sound =
      {
        {
          filename = "__base__/sound/laser.ogg",
          volume = 0.4
        }
      },
    
	   ammo_type =
     {
      type = "projectile",
      category = "laser-turret",
      action =
      {
        {
          type = "direct",
          action_delivery =
          {
            {
              type = "projectile",
              projectile = "laser",
              starting_speed = 0.28
            }
          }
        }
      }
     },
	 
	 	 animation =
     {
       filename = "__F-mod__/resources/entity/planet-buildings/person-fire.png",
       priority = "high",
       width = 58,
       height = 72,
       frame_count = 5,
       direction_count = 8,
       shift = {0, -0.6}
     },
	 
	},
   	 
    movement_speed = 0.1,
    distance_per_frame = 0.15,
	pollution_to_join_attack = 5000,
    dying_sound =
    {
      {
        filename = "__base__/sound/creatures/creeper-death-4.ogg",
        volume = 0
      }
    },
    run_animation =
    {
      filename = "__F-mod__/resources/entity/planet-buildings/person.png",
      priority = "high",
	  width = 58,
      height = 72,
      frame_count = 30,
      direction_count = 18,
      shift = {0, -0.6}
    }
   },
})