data:extend({
  {
    type= "assembling-machine",
    name= "f-blast-furnace",
    flags= {"placeable-neutral", "player-creation"},
	
	collision_box= {{-2.4, -2.4}, {2.4, 2.4}},
    selection_box= {{-2.5, -2.5}, {2.5, 2.5}},
	
    --collision_box= {{-3.4, -2.4}, {1.4, 2.9}},
    --selection_box= {{-3.5, -2.4}, {1.5, 3.0}},
    minable= { hardness= 0.2, mining_time= 0.5, result= "f-blast-furnace" },
    crafting_categories= { "f-blast-furnace" },
    max_health= 150,
    ingredient_count= 3,
    energy_usage="300kW",
	crafting_speed=1,
	icon="__F-mod__/resources/icons/blastfurnace icon.png",
    energy_source=
    {
      type= "electric",
	  usage_priority = "secondary-input",
    },
    animation=
    {
      filename= "__F-mod__/resources/entity/blast-furnace/blastfurnace.png",
      priority= "medium",
      width= 212,
      height= 180,
      line_length= 5,
      frame_count= 16,
	  shift = {0.8, 0.18}
    },
	fluid_boxes ={
      {
        production_type = "output",
        --pipe_covers = pipecoverspictures(),
        base_area = 10,
        base_level = 1,
        pipe_connections = {{ type="output", position = {-3, 1} }}
      }, 
	  {
        production_type = "output",
        --pipe_covers = pipecoverspictures(),
        base_area = 10,
        base_level = 1,
        pipe_connections = {{ type="output", position = {-3, -1} }}
      }, 
      {
        production_type = "output",
        --pipe_covers = pipecoverspictures(),
        base_level = 1,
        pipe_connections = {{ type="output", position = {3,1} }}
      }, 
	  {
        production_type = "output",
        --pipe_covers = pipecoverspictures(),
        base_level = 1,
        pipe_connections = {{ type="output", position = {3,-1} }}
      }, 
      {
        production_type = "input",
        --pipe_covers = pipecoverspictures(),
        base_area = 10,
        base_level = -1,
        pipe_connections = {{ type="input", position = {1, -3} }}
      }, 
	  {
        production_type = "input",
        --pipe_covers = pipecoverspictures(),
        base_area = 10,
        base_level = -1,
        pipe_connections = {{ type="input", position = {-1, -3} }}
      }, 
      {
        production_type = "input",
        --pipe_covers = pipecoverspictures(),
        base_level = -1,
        pipe_connections = {{ type="input", position = {1,3} }}
      }, 
	  {
        production_type = "input",
        --pipe_covers = pipecoverspictures(),
        base_level = -1,
        pipe_connections = {{ type="input", position = {-1,3} }}
      },
	 },
	},

  
{
   	type = "recipe",
   	name =  "f-blast-furnace",
   	result= "f-blast-furnace",
   	ingredients= { {"advanced-circuit", 10}, {"steel-plate", 50}, {"copper-plate", 100}, {"iron-plate", 100}, {"silver-plate", 50}, {"copper-cable", 10}},
	energy_required= 60,
    enabled= "false",
	category= "crafting"
  },
  
	{
		type= "item",
		name= "f-blast-furnace",
		order= "z-z-b-f",
		place_result= "f-blast-furnace",
		stack_size= 10,
		flags= { "goes-to-quickbar" },
		icon="__F-mod__/resources/icons/blastfurnace icon.png",
		subgroup = "production-machine",
	},
})

